Workload Balancing Overview

Workload Balancing is a XenServer appliance that balances your pool by relocating virtual machines onto the best possible servers for their workload in a resource pool. For example, Workload Balancing can:

  • Balance virtual-machine workloads across hosts in a XenServer resource pool
  • Determine the best host on which to start a virtual machine
  • Determine the best host on which to power on a virtual machine that you powered off
  • Determine the best host for each of the host's virtual machines when you put that host into Maintenance mode
Note: Workload Balancing is available for customers using Citrix XenServer Per-Socket or Citrix XenServer for XenDesktop licenses. To learn more about XenServer licensing, see About XenServer Licensing. To buy a XenServer license, click here.

Depending on your preference, Workload Balancing can accomplish these tasks automatically or prompt you to accept its optimization, consolidation, and placement recommendations. You can also configure Workload Balancing to power off hosts automatically during periods of low usage (for example, to save power at night).

Workload Balancing evaluates the utilization of virtual-machine workloads across a pool and, when a host reaches one of its thresholds, relocates the virtual machine to a different host in the pool.

To ensure the rebalancing and placement recommendations align with your environment's needs, you can configure Workload Balancing to optimize workloads for resource performance or to maximize density. These optimization modes can be configured to change automatically at predefined times or stay the same at all times. For additional granularity, you can fine-tune the weighting of individual resource metrics (CPU, network, memory, and disk).

To help you perform capacity planning, Workload Balancing provides historical reports about host and pool health, optimization and virtual-machine performance, and virtual-machine motion history.


Getting Started with Workload Balancing

If your license includes Workload Balancing, you can download the Workload Balancing virtual appliance and get it up and running using the following process:

  1. Download the Workload Balancing virtual appliance package from My Account at citrix.com and import it into XenCenter.
  2. Configure the Workload Balancing virtual appliance using the Workload Balancing Configuration wizard, which appears in the appliance's Console tab in XenCenter after you import the virtual appliance.
  3. Connect your pool to the Workload Balancing virtual appliance as described in Connecting to Workload Balancing.

    More information about these steps is in the Workload Balancing Quick Start.

Note: You should have Citrix XenServer Per-Socket or Citrix XenServer for XenDesktop license in order to use Workload Balancing. To learn more about XenServer licensing, see About XenServer Licensing. To buy a XenServer license, click here.


Workload Balancing Basic Concepts

Workload Balancing captures data for resource performance on virtual machines and physical hosts. It uses this data, combined with the preferences you set, to provide optimization and placement recommendations. Workload Balancing stores performance data in an internal database: the longer Workload Balancing runs, the better its recommendations become.

Workload Balancing recommends moving virtual-machine workloads across a pool to get the maximum efficiency, which means either performance or density depending on your goals. Within a Workload Balancing context:

  • Performance refers to the usage of physical resources on a host (for example, the CPU, memory, network, and disk utilization on a host). When you set Workload Balancing to maximize performance, it recommends placing virtual machines to ensure the maximum amount of resources are available for each virtual machine.
  • Density refers to the number of virtual machines on a host. When you set Workload Balancing to maximize density, it recommends placing virtual machines on as few hosts as possible, while ensuring they maintain adequate computing power, so you can reduce the number of hosts powered on in a pool.

Workload Balancing lets you modify settings for placement (performance or density), power management, automation, metric weightings, and performance thresholds.

Workload Balancing will not conflict with High Availability settings; High Availability settings always take precedence.


Connecting to Workload Balancing

After importing the Workload Balancing virtual appliance and running the Workload Balancing Configuration wizard, you must connect the pool you want monitored to Workload Balancing. To do so, use either the Connect to WLB Server dialog box in XenCenter or the XE commands.

Prerequisites

To complete the XenCenter procedure that follows, you need the:

  • IP address or Fully Qualified Domain Name (FQDN) and port of the Workload Balancing virtual appliance.
  • Credentials for the resource pool (that is, the pool master) you want Workload Balancing to monitor.
  • Credentials for the account you created on the Workload Balancing appliance. This is often known as the Workload Balancing user account. XenServer uses this account to communicate with Workload Balancing. (You created this account on the Workload Balancing virtual appliance during Workload Balancing Configuration.)

If you want to specify the Workload Balancing virtual appliance's FQDN when connecting to the Workload Balancing server (that is, in the Connect to WLB Server dialog), you must first manually add its host name to your DNS. If you want to configure Trusted Authority certificates, Citrix recommends specifying either an FQDN or an IP address that does not expire.

When you first connect to Workload Balancing, it uses the default thresholds and settings for balancing workloads. Automatic features, such as Automated Optimization Mode, Power Management, and Automation, are disabled by default.

Important: After Workload Balancing is running for a period of time, if you do not receive optimal placement recommendations, Citrix strongly recommends you evaluate your performance thresholds as described in Evaluating the Effectiveness of Your Optimization Thresholds. It is critical to set the correct thresholds for your environment for Workload Balancing recommendations to be optimal.

To connect to the Workload Balancing virtual appliance

  1. In the Resources pane of XenCenter, select XenCenter > your-resource-pool.
  2. In the Properties pane, click the WLB tab.
  3. In the WLB tab, click Connect. The Connect to WLB Server dialog box appears.
  4. In the Server Address section, dialog box, enter the following:
    • In the Address box, type the IP address or FQDN of the Workload Balancing server. An example of an FQDN is WLB-appliance-computername.yourdomain.net.
    • Enter the port number in the Port box. XenServer uses this port to communicate with Workload Balancing.

      By default, XenServer connects to Workload Balancing (specifically the Web Service Host service) on port 8012. If you changed the port number during Workload Balancing Configuration, you must enter that port number in the Port box.

      Important: Do not change the default port number unless you changed the default port during Workload Balancing Configuration. The port number specified during Configuration, in any firewalls, and in the Connect to WLB Server dialog must match.
  5. In the WLB Server Credentials section, enter the user name (for example, wlbuser) and password the XenServer will use to connect to the Workload Balancing virtual appliance. This must be the account you created during Workload Balancing Configuration. By default, the user name for this account is wlbuser.
  6. In the XenServer Credentials section, enter the user name and password for the pool you are configuring. Workload Balancing will use these credentials to connect to each of the hosts in that pool. To use the credentials with which you are currently logged into XenServer, select the Use the current XenCenter credentials check box. If you have assigned permissions to the account using the Role Based Access Control feature (RBAC), be sure they are sufficient to use Workload Balancing. See Definitions of RBAC roles and permissions.
  7. After connecting to the Workload Balancing appliance, if you want to change the settings for thresholds or the priority given to specific resources, see Editing Workload Balancing Settings.


Introduction to Basic Tasks

Workload Balancing is a powerful XenServer component that includes many features designed to optimize the workloads in your environment, such as host power management, the ability to schedule optimization-mode changes, and running reports. In addition, you can fine-tune the criteria Workload Balancing uses to make optimization recommendations.

However, when you first begin using Workload Balancing, there are two main tasks you will probably use Workload Balancing for on a daily (or regular) basis:

  • Determining the best host on which to start a virtual machine
  • Accepting Workload Balancing optimization recommendations

For information about obtaining and configuring the Workload Balancing virtual appliance, see the Workload Balancing Quick Start.

Determining the best host on which to start a VM

See also Choosing an Optimal Server for VM Initial Placement, Migrate, and Resume.

Workload Balancing can provide recommendations about the host Determining the host on which to start a VM (VM placement) is handy when you want to restart a powered off virtual machine and when you want to migrate a virtual machine to a different host. It may also be useful in XenDesktop environments.

Accepting Workload Balancing recommendations

See also Accepting Optimization Recommendations.

After Workload Balancing is running for a while, it begins to make recommendations about ways in which you can improve your environment. For example, if your goal is to improve VM density on hosts, with the appropriate settings, Workload Balancing will issue a recommendation to consolidate virtual machines on a host. Assuming you are not running in automated mode, you can choose to either apply this recommendation or just simply ignore it.

Both of these tasks, and the way in which you perform them in XenCenter, are explained in more depth in the sections that follow. Another frequently used task is running reports about the workloads in your environment, which is described in Generating and Managing Workload Balancing Reports.

Important: After Workload Balancing is running for a period of time, if you do not receive optimal placement recommendations, Citrix strongly recommends you evaluate your performance thresholds as described in the Workload Balancing Administrator's Guide. It is critical to set Workload Balancing to the correct thresholds for your environment or its recommendations might not be appropriate or occur at the correct times.


Choosing an Optimal Server for VM Initial Placement, Migrate, and Resume

When Workload Balancing is enabled and you start a virtual machine that is offline, XenCenter provides recommendations to help you determine the optimal physical host in the resource pool on which to start a virtual machine. The recommendations are also known as star ratings since stars are used to indicate the best host.

More stars appear beside host17 since this is the optimal host on which to start the VM. host16 does not have any stars beside it, which indicates that host is not recommended, but since it is enabled the user can select that host. host18 is greyed out due to insufficient memory, so the user cannot select it.

How do placements work?

When Workload Balancing is enabled, XenCenter provides star ratings to indicate the optimal hosts for starting a virtual machine, including when you want to start the virtual machine when it is powered off or suspended and when you want to migrate the virtual machine to a different server (Migrate and Maintenance Mode).

When you use these features with Workload Balancing enabled, host recommendations appear as star ratings beside the name of the physical host. Five empty stars indicates the lowest-rated (least optimal) server. When it is not possible to start or move a virtual machine to a host, when you use the menu command for one of the placement features, the host name is greyed out and the reason it cannot accept the VM appears beside it.

In general, Workload Balancing functions more effectively and makes better, less frequent optimization recommendations if you start virtual machines on the hosts it recommends (that is, by using one of the placement features to select the host with the most stars beside it).

What does optimal mean?

The term optimal refers to the physical server best suited to hosting your workload. There are several factors Workload Balancing uses when determining which host is optimal for a workload:

  • The amount of resources available on each host in the pool. When a pool is running in Maximum Performance mode, Workload Balancing tries to balance the virtual machines across the hosts in the pool so that all virtual machines have good performance. When a pool is running in Maximum Density mode, Workload Balancing tries to place virtual machines onto hosts as densely as possible while ensuring the virtual machines have sufficient resources.
  • The optimization mode in which the pool is running (Maximum Performance or Maximum Density). When a pool is running in Maximum Performance mode, Workload Balancing tries to place virtual machines on hosts with the most resources available of the type the VM requires. In Maximum Density mode, Workload Balancing tries to place virtual machines on hosts that already have virtual machines running so that virtual machines are running on as few hosts as possible.
  • The amount and type of resources the VM requires. After Workload Balancing has monitored a virtual machine for a while, it uses the VM metrics it gathered to make placement recommendations according to the type of resources the virtual machine requires. For example, Workload Balancing may select a host with less available CPU but more available memory if it is what the VM requires (based on its past performance history). It should, however, be noted that Workload Balancing only makes a recommendation if it determines the current host is under resource pressure.

To start a virtual machine on the optimal server

  1. In the Resources pane of XenCenter, select the virtual machine you want to start.
  2. From the VM menu, select Start on Server and then select one of the following:
    • Optimal Server. The optimal server is the physical host that is best suited to the resource demands of the virtual machine you are starting. Workload Balancing determines the optimal server based on its historical records of performance metrics and your placement strategy. The optimal server is the server with the most stars.
    • One of the servers with star ratings listed under the Optimal Server command. Five stars indicates the most-recommended (optimal) server and five empty stars indicates the least-recommended server.

To resume a virtual machine on the optimal server

  1. In the Resources pane of XenCenter, select the suspended virtual machine you want to resume.
  2. From the VM menu, select Resume on Server and then select one of the following:
    • Optimal Server. The optimal server is the physical host that is best suited to the resource demands of the virtual machine you are starting. Workload Balancing determines the optimal server based on its historical records of performance metrics and your placement strategy. The optimal server is the server with the most stars.
    • One of the servers with star ratings listed under the Optimal Server command. Five stars indicates the most-recommended (optimal) server and five empty stars indicates the least-recommended server.


Accepting Optimization Recommendations

Workload Balancing provides recommendations about ways you can migrate virtual machines to optimize your environment. Optimization recommendations appear in the WLB tab in XenCenter.

This illustration shows a screen capture of the Optimization Recommendations list, which appears on the WLB tab. The Reason column displays the purpose of the recommendation. The Operation column displays the behavior change suggested for that optimization recommendation. This screen capture shows an optimization recommendation for a virtual machine, HA-prot-VM-7, and a host, host17.domain4.bedford4.ctx4.

Basis for optimization recommendations

Optimization recommendations are based on the:

  • Placement strategy you select (that is, the placement optimization mode), as described in Adjusting the Optimization Mode
  • Performance metrics for resources such as a physical host's CPU, memory, network, and disk utilization
  • The role of the host in the resource pool. When making placement recommendations, Workload Balancing considers only the pool master if no other host can accept the workload. (Likewise, when a pool is operating in Maximum Density mode, Workload Balancing considers the pool master last when determining the order in which to fill hosts with virtual machines.)

The optimization recommendations display the name of the virtual machine that Workload Balancing recommends relocating, the host it currently resides on, and the host Workload Balancing recommends as the machine's new location. The optimization recommendations also display the reason Workload Balancing recommends moving the virtual machine (for example, "CPU" to improve CPU utilization).

After you accept an optimization recommendation, XenServer relocates all virtual machines listed as recommended for optimization.

Tip: You can find out the optimization mode for a resource pool by selecting the pool in XenCenter and checking the Configuration section of the WLB tab.

To accept an optimization recommendation

  1. Select the pool for which you want to display recommendations in the Resources pane and then click on the WLB tab. If there are any recommended optimizations for any virtual machines on the selected resource pool, they display on the WLB tab.
  2. To accept the recommendations, click Apply Recommendations. XenServer begins moving all virtual machines listed in the Optimization Recommendations section to their recommended servers.

    After you click Apply Recommendations, you can click the Logs tab to display the progress of the virtual machine migration.

Understanding WLB recommendations under High Availability

If you have Workload Balancing and the XenServer High Availability feature enabled in the same pool, it is helpful to understand how the two features interact. Workload Balancing is designed not to interfere with High Availability. If there is a conflict between a Workload Balancing recommendation and a High Availability setting, the High Availability setting always takes precedence. In practice, this means:

  • Workload Balancing will not automatically power off any hosts beyond the number specified in the Failures allowed box in the Configure HA dialog.
    • However, Workload Balancing may still make recommendations to power off more hosts than the number of host failures to tolerate. (For example, Workload Balancing will still make a recommendation to power off two hosts when High Availability is only configured to tolerate one host failure.) However, when you attempt to apply the recommendation, XenCenter may display an error message stating that High Availability will no longer be guaranteed.
    • When Workload Balancing is running in automated mode and has power management enabled, any recommendations that exceed the number of host failures to tolerate are ignored. In this situation, if you look in the Workload Balancing log, you will see a message that says a power-management recommendation was not applied because High Availability is enabled.


Working with Workload Balancing Reports

This topic provides general information about Workload Balancing historical reports and an overview of where to find additional information about these reports.

To generate a Workload Balancing report, you must have imported the Workload Balancing appliance and connected the pool to it.

Introduction

Workload Balancing provides reporting on three types of objects: physical hosts, resource pools, and virtual machines. At a high level, Workload Balancing provides two types of reports:

  • Historical reports that display information by date
  • "Roll up" style reports

Workload Balancing provides some reports for auditing purposes, so you can determine, for example, the number of times a virtual machine moved.

Types of Reports

Workload Balancing offers several different reports about the pool, hosts, and VMs. For more information, see Workload Balancing Report Glossary.

Generating reports

Workload Balancing lets you generate reports, export them as PDFs or spreadsheets, and print them out. For more information, see Generating and Managing Workload Balancing reports.


Using Workload Balancing Reports for Tasks

The Workload Balancing reports can help you perform capacity planning, determine virtual-machine health, and evaluate the effectiveness of your configured threshold levels.

Evaluating the effectiveness of your performance thresholds

You can use the Pool Health report to evaluate the effectiveness of your optimization thresholds. Workload Balancing provides default threshold settings. However, you might need to adjust these defaults for them to provide value in your environment. If you do not have the thresholds adjusted to the correct level for your environment, Workload Balancing recommendations might not be appropriate for your environment.

Troubleshooting administrative changes

You can use the Pool Audit Trail report to determine not only the source (that is, user account) of problematic changes but also the event or task that user performed.


Generating and Managing Workload Balancing Reports

This topic provides basic instructions for using Workload reports, including how to generate, navigate in, print, and export reports.

To generate a Workload Balancing report

  1. In the Resources pane of XenCenter, select your-resource-pool.
  2. From the Pool menu, select View Workload Reports.
    Tip: You can also display the Workload Reports screen from the WLB tab by clicking the Reports button.
  3. From the Workload Reports screen, select a report from the left pane.
  4. Select the Start Date and the End Date for the reporting period. Depending on the report you select, you might need to specify a host in the Host list box.
  5. Click Run Report. The report displays in the report window.

To navigate in a Workload Balancing report

After generating a report, you can use the toolbar buttons in the report to navigate and perform certain tasks. To display the name of a toolbar button, pause your mouse over toolbar icon.

Report Toolbar Buttons:

Document Map. Displays a document map that helps you navigate through long reports.
Page Forward/Back. Moves one page ahead or back in the report.
Back to Parent Report. Returns to the parent report when working with drill-through reports.
Note: This button is only available in drill-through reports, such as the Pool Health report.
Stop Rendering. Stops the report generation.
Print. Prints a report and specify general printing options, such as the printer, the number of pages, and the number of copies.
Print Layout. Displays a preview of the report before you print it. To exit Print Layout, click the Print Layout button again.
Page Setup. Specifies printing options such as the paper size, page orientation, and margins.
Export. Exports the report as an Acrobat (.pdf) file or as an Excel file with a .xls extension.
Find. Searches for a word in a report, such as the name of a virtual machine.

To print a Workload Balancing report

Before you can print a report, you must first generate it.

  1. (Optional.) To preview the printed document, click [image] Print Layout.
  2. (Optional.) To change the paper size/source, page orientation, or margins, click [image] Page Setup.
  3. Click [image] Print.

To export a Workload Balancing report

You can export a report in Microsoft Excel and Adobe Acrobat (.pdf) formats.

After generating the report, click [image] Export and select one of the following:

  • Excel
  • Acrobat (.pdf) file
Note: The amount of data included when you export a report may differ depending on the export format. Reports exported to Excel include all the data available for the report, including "drilldown" data, whereas reports displayed in XenCenter or exported as .pdf only contain the data that you selected when you generated the report.


Workload Balancing Report Glossary

This topic provides information about the following Workload Balancing reports.

Chargeback Utilization Analysis

You can use the Chargeback Utilization Analysis report ("chargeback report") to determine how much of a resource (such as a physical server) a specific department within your organization used. Specifically, the report shows information about all the virtual machines in your pool, including their availability and resource utilization. Since this report shows virtual machine availability ("up time"), it can help you demonstrate Service Level Agreements compliance and availability.

The chargeback report can help you implement a simple chargeback solution and facilitate billing. To bill customers for usage of a specific resource, generate the report, save it as Excel, and then customize the spreadsheet data to include your price per unit or import the Excel data into your billing system.

If you know that you will want to bill internal or external customers for virtual machine usage, consider incorporating department or customer names in your virtual machine naming conventions. This will make reading chargeback reports easier.

The resource reporting in the chargeback report is, in some cases, based on the allocation of physical resources to individual virtual machines.

Likewise, because XenServer lets you allocate fixed or automatic allocations of memory, the average memory data in this report is based on the amount of memory currently allocated to the virtual machine, whether it is through a fixed memory allocation or an automatically adjusting memory allocation (Dynamic Memory Control).

The chargeback report contains the following columns of data:

  • VM Name. The name of the virtual machine to which the data in the columns in that row applies.
  • VM Uptime. The number of minutes the virtual machine was powered on (or, more specifically, appears with a green icon beside it in XenCenter).
  • VCPU Allocation. The number of virtual CPUs configured on the virtual machine. Each virtual CPU receives an equal share of the physical CPU(s) on the host. For example, if you configured eight virtual CPUs on a host that contains two physical CPUs and this column had "1" in it, then this value is equal to 2/16 of the total processing power on the host.
  • Minimum CPU Usage (%). The lowest recorded value for virtual CPU utilization in the reporting period. This value is expressed as a percentage of the virtual machine's virtual CPU capacity, and the capacity is based on the number of virtual CPUs allocated to the virtual machine. For example, if, when you created the virtual machine, you allocated one virtual CPU to it, Minimum CPU Usage represents the lowest percentage of virtual CPU usage XenServer recorded, even if it was only for a second. If you allocated two virtual CPUs to the virtual machine, the value in this column represents the lowest usage of the combined capacity of both virtual CPUs, expressed as a percentage.

    Ultimately, the percentage of CPU usage represents the lowest recorded workload that virtual CPU handled. For example, if you allocate one virtual CPU to a virtual machine and the physical CPU on the host is 2.4 GHz, you are allocating one-eighth of 2.4 GHz to the virtual machine. This means that if the virtual machine's allocated capacity is 0.3GHz, or 300MHz, and the Minimum CPU Usage for the virtual machine was 20%, the virtual machine's lowest usage of the physical host's CPU during the reporting period was 60MHz.

  • Maximum CPU Usage (%). The highest percentage of the virtual machine's virtual CPU capacity that the virtual machine consumed during the reporting period. The CPU capacity consumed is a percentage of the virtual CPU capacity you allocated to the virtual machine. For example, if, when you created the virtual machine, you allocated one virtual CPU to it, the Maximum CPU Usage represents the highest recorded percentage of virtual CPU usage during the time reported. If you allocated two virtual CPUs to the virtual machine, the value in this column represents the highest utilization from the combined capacity of both virtual CPUs.
  • Average CPU Usage (%). Average CPU Usage (%). The average amount, expressed as a percentage, of the virtual machine's virtual CPU capacity that was in use during the reporting period. The CPU capacity is the virtual CPU capacity you allocated to the virtual machine. If you allocated two virtual CPUs to the virtual machine, the value in this column represents the average utilization from the combined capacity of both virtual CPUs.
  • Total Storage Allocation (GB). The amount of disk space that is currently allocated to the virtual machine at the time the report was run. Frequently, unless you modified it, this disk space is the amount of disk space you allocated to the virtual machine when you created it.
  • Virtual NIC Allocation. The number of virtual interfaces (VIFs) allocated to the virtual machine.
  • Current Minimum Dynamic Memory (MB).
    • Fixed memory allocation. If you assigned a virtual machine a fixed amount of memory (for example, 1024MB), the same amount of memory appears in the following columns: Current Minimum Dynamic Memory (MB), Current Maximum Dynamic Memory (MB), Current Assigned Memory (MB), and Average Assigned Memory (MB).
    • Dynamic memory allocation. If you configured XenServer to adjust a virtual machine's memory automatically based on a range (that is, you enabled Dynamic Memory Control), the minimum amount of memory specified in the range appears in this column. For example, if in the Memory Settings dialog box in XenCenter, you selected the Automatically allocate memory within this range option for this virtual machine and then specified the range values as 1024MB as the minimum memory and 2048MB as the maximum memory, then 1024MB will appear in the Current Minimum Dynamic Memory (MB) column.
  • Current Maximum Dynamic Memory (MB).
    • Dynamic memory allocation. If XenServer is set to adjust a VM's memory automatically based on a range, the maximum amount of memory specified in the range appears in this column. For example, if the memory range you provided was 1024MB minimum and 2048MB maximum, then 2048MB will appear in the Current Maximum Dynamic Memory (MB) column.
    • Fixed memory allocation. If you assign a VM a fixed amount of memory (for example, 1024MB), the same amount of memory appears in the following columns: Current Minimum Dynamic Memory (MB), Current Maximum Dynamic Memory (MB), Current Assigned Memory (MB), and Average Assigned Memory (MB).
  • Current Assigned Memory (MB).
    • Dynamic memory allocation. When Dynamic Memory Control is configured, this value indicates the amount of memory XenServer is currently allocating to the virtual machine at the time at which the report was run.
    • Fixed memory allocation. If you assign a virtual machine a fixed amount of memory (for example, 1024MB), the same amount of memory appears in the following columns: Current Minimum Dynamic Memory (MB), Current Maximum Dynamic Memory (MB), Current Assigned Memory (MB), and Average Assigned Memory (MB).
    Note: If you change the virtual machine's memory allocation immediately before running this report, the value reflected in this column reflects the new memory allocation you configured.
  • Average Assigned Memory (MB).
    • Dynamic memory allocation. When Dynamic Memory Control is configured, this value indicates the average amount of memory XenServer allocated to the virtual machine over the reporting period.
    • Fixed memory allocation. If you assign a virtual machine a fixed amount of memory (for example, 1024MB), the same amount of memory appears in the following columns: Current Minimum Dynamic Memory (MB), Current Maximum Dynamic Memory (MB), Current Assigned Memory (MB), and Average Assigned Memory (MB).
    Note: If you change the virtual machine's memory allocation immediately before running this report, the value displayed in this column may not change from what it would have previously displayed. The value in this column reflects the average over the time period.
  • Average Network Reads (BPS). The average amount of data (in bits per second) the virtual machine received during the reporting period.
  • Average Network Writes (BPS). The average amount of data (in bits per second) the virtual machine sent during the reporting period.
  • Average Network Usage (BPS). The combined total (in bits per second) of the Average Network Reads and Average Network Writes. For example, if a virtual machine sent, on average, 1,027 bits per second and received, on average, 23,831 bits per second over the reporting period, then the Average Network Usage would be the combined total of these two values: 24,858 bits per second.
  • Total Network Usage (BPS). The total of all network read and write transactions in bits per second over the reporting period.

Host Health History

This report displays the performance of resources (CPU, memory, network reads, and network writes) on specific host in relation to threshold values.

The colored lines (red, green, yellow) represent your threshold values. You can use this report with the Pool Health report for a host to determine how a particular host's performance might be affecting overall pool health. When you are editing the performance thresholds, you can use this report for insight into host performance.

You can display resource utilization as a daily or hourly average. The hourly average lets you see the busiest hours of the day, averaged, for the time period.

To view report data grouped by hour, expand + Click to view report data grouped by house for the time period under the Host Health History title bar.

Workload Balancing displays the average for each hour for the time period you set. The data point is based on a utilization average for that hour for all days in the time period. For example, in a report for May 1, 2009 to May 15, 2009, the Average CPU Usage data point represents the resource utilization of all fifteen days at 12:00 hours combined together as an average. That is, if CPU utilization was 82% at 12 PM on May 1st, 88% at 12 PM on May 2nd, and 75% on all other days, the average displayed for 12 PM is 76.3%.

Pool Optimization Performance History

The optimization performance report displays optimization events (that is, when you optimized a resource pool) against that pool's average resource usage. Specifically, it displays resource usage for CPU, memory, network reads, and network writes.

The dotted line represents the average usage across the pool over the period of days you select. A blue bar indicates the day on which you optimized the pool.

This report can help you determine if Workload Balancing is working successfully in your environment. You can use this report to see what led up to optimization events (that is, the resource usage before Workload Balancing recommended optimizing).

This report displays average resource usage for the day; it does not display the peak utilization, such as when the system is stressed. You can also use this report to see how a resource pool is performing if Workload Balancing is not making optimization recommendations.

In general, resource usage should decline or be steady after an optimization event. If you do not see improved resource usage after optimization, consider readjusting threshold values. Also, consider whether or not the resource pool has too many virtual machines and whether or not new virtual machines were added or removed during the time frame you specified.

Pool Audit Trail

This report displays the contents of the XenServer Audit Log, a XenServer feature designed to log attempts to perform unauthorized actions and select authorized actions, including import/export, host and pool backups, and guest and host console access. The report gives more meaningful information when XenServer administrators are given their own user accounts with distinct roles assigned to them using the Role-Based Access Control feature. For information about the Audit Log feature, see the audit log documentation in the Workload Balancing Administrator's Guide.

Important: To run the audit log report, the Audit Logging feature must be enabled. By default, the Audit Log is always enabled in the Workload Balancing virtual appliance. However, the audit log only captures limited amounts of data for specific objects and actions.

This report displays the following:

  • Time. The time XenServer recorded the user's action.
  • Event Action. The action that occurred. For definitions of these actions, see Audit Log Event Names.
  • User Name. The name of the person who created the session in which the action was performed. In some cases, this may be the User ID.
  • Access. Whether or not the user had permission to perform the action.
  • Event Object. The object that was the subject of the action (for example, a virtual machine).
  • Object Name. The name of the object (for example, the name of the virtual machine).
  • Succeeded. This provides the status of the action (that is, whether or not it was successful).

Pool Health

The pool health report displays the percentage of time a resource pool and its hosts spent in four different threshold ranges: Critical, High, Medium, and Low. You can use the Pool Health report to evaluate the effectiveness of your performance thresholds.

A few points about interpreting this report:

  • Resource utilization in the Average Medium Threshold (blue) is the optimum resource utilization regardless of the placement strategy you selected. Likewise, the blue section on the pie chart indicates the amount of time that host used resources optimally.
  • Resource utilization in the Average Low Threshold Percent (green) is not necessarily positive. Whether Low resource utilization is positive depends on your placement strategy. For example, if your placement strategy is Maximum Density and most of the time your resource usage was green, Workload Balancing might not be fitting the maximum number of virtual machines possible on that host or pool. If this is the case, you should adjust your performance threshold values until the majority of your resource utilization falls into the Average Medium (blue) threshold range.
  • Resource utilization in the Average Critical Threshold Percent (red) indicates the amount of time average resource utilization met or exceeded the Critical threshold value.

If you double-click on a pie chart for a host's resource usage, XenCenter displays the Host Health History report for that resource (for example, CPU) on that host. Clicking the Back to Parent Report toolbar button returns you to the Pool Health history report. Note: This button is only available in drill-through reports, such as the Pool Health report.

If you find the majority of your report results are not in the Average Medium Threshold range, you probably need to adjust the Critical threshold for this pool. While Workload Balancing provides default threshold settings, these defaults are not effective in all environments. If you do not have the thresholds adjusted to the correct level for your environment, Workload Balancing's optimization and placement recommendations might not be appropriate. For more information, see Changing the Critical Thresholds.

Note: The High, Medium, and Low threshold ranges are based on the Critical threshold value.

Pool Health History

This report provides a line graph of resource utilization on all physical hosts in a pool over time. It lets you see the trend of resource utilization - if it tends to be increasing in relation to your thresholds (Critical, High, Medium, and Low). You can evaluate the effectiveness of your performance thresholds by monitoring trends of the data points in this report.

Workload Balancing extrapolates the threshold ranges from the values you set for the Critical thresholds. Although similar to the Pool Health report, the Pool Health History report displays the average utilization for a resource on a specific date rather than the amount of time overall the resource spent in a threshold.

With the exception of the Average Free Memory graph, the data points should never average above the Critical threshold line (red). For the Average Free Memory graph, the data points should never average below the Critical threshold line (which is at the bottom of the graph). Because this graph displays free memory, the Critical threshold is a low value, unlike the other resources.

A few points about interpreting this report:

  • When the Average Usage line in the chart approaches the Average Medium Threshold (blue) line, it indicates the pool's resource utilization is optimum regardless of the placement strategy configured.
  • Resource utilization approaching the Average Low Threshold (green) is not necessarily positive. Whether Low resource utilization is positive depends on your placement strategy. For example, if your placement strategy is Maximum Density and most days the Average Usage line is at or below the green line, Workload Balancing might not be placing virtual machines as densely as possible on that pool. If this is the case, you should adjust the pool's Critical threshold values until the majority of its resource utilization falls into the Average Medium (blue) threshold range.
  • When the Average Usage line intersects with the Average Critical Threshold Percent (red), this indicates the days when the average resource utilization met or exceeded the Critical threshold value for that resource.

If you find the data points in the majority of your graphs are not in the Average Medium Threshold range, but you are satisfied with the performance of this pool, you might need to adjust the Critical threshold for this pool. For more information, see Changing the Critical Thresholds.

Pool Optimization History

The Pool Optimization History report provides chronological visibility into Workload Balancing optimization activity.

Optimization activity is summarized graphically and in a table. Drilling into a date field within the table displays detailed information for each pool optimization performed for that day.

This report lets you see the following information:

  • VM Name. The name of the virtual machine that Workload Balancing optimized.
  • Reason. The reason for the optimization.
  • Status. If the optimization was successful.
  • From Host. The physical server where the virtual machine was originally hosted.
  • To Host. The physical server where the virtual machine was moved.
  • Time. The time when the optimization occurred.
Tip: You can also generate a Pool Optimization History report from the WLB tab, by clicking the View History link.

Virtual Machine Motion History

This line graph displays the number of times virtual machines moved on a resource pool over a period of time. It indicates if a move resulted from an optimization recommendation and to which host the virtual machine moved. This report also indicates the reason for the optimization. You can use this report to audit the number of moves on a pool.

Some points about interpreting this report:

  • The numbers on the left side of the chart correspond with the number of moves possible, which is based on how many virtual machines are in a resource pool.
  • You can look at details of the moves on a specific date by expanding the + sign in the Date section of the report.

Virtual Machine Performance History

This report displays performance data for each virtual machine on a specific host for a time period you specify. Workload Balancing bases the performance data on the amount of virtual resources allocated for the virtual machine. For example, if the Average CPU Usage for your virtual machine is 67%, this means that your virtual machine was using, on average, 67% of its virtual CPU for the period you specified.

The initial view of the report displays an average value for resource utilization over the period you specified.

Expanding the + sign displays line graphs for individual resources. You can use these graphs to see trends in resource utilization over time.

This report displays data for CPU Usage, Free Memory, Network Reads/Writes, and Disk Reads/Writes.


Audit Log Event Names

The following table defines some events that appear frequently in the XenServer Audit Log and the Pool Audit Trail report. For additional event definitions, see the Citrix XenServer Management API.

In the Pool Audit Trail report, the events listed in the Event Action column apply to a pool, VM, or host. To determine what the events apply to, see the Event Object and Object Name columns in the report.

Event action | User action
SR.destroy | Destroyed the storage repository.
VM.start | Started a virtual machine.
http/get_audit_log | Retrieved Audit Log.
reboot | Restarted a XenServer host.
disable | Put the host into a state in which no new VMs can be started.
migrate | Migrated all VMs off of this host, provided it was possible.
suspend | VM state was saved to disk and is no longer running.
hard_shutdown | Stopped executing the specified VM without attempting a clean shutdown.
hard_reboot | Stopped executing the specified VM without attempting a clean shutdown and immediately restarted the VM.
start_on | Started the specified VM on a particular host.
snapshot_with_quiesce | Took a snapshot of the specified VM with quiesce, making a new VM.
enable_ha | Turn on High Availability mode.
copy | Copied the specified VM, making a new VM.
disable_ha | Turn off High Availability mode.
join_force | Instructed (forced) host to join a new pool.
join | Instructed host to join a new pool.
shutdown | Shutdown the specified VM.
pool_migrate | Migrated a VM to another host.
pool.retrieve_wlb_recommendations | Retrieved Workload Balancing recommendations for this pool.


Editing Workload Balancing Settings

After connecting to the Workload Balancing virtual appliance, you can edit the settings Workload Balancing uses to calculate placement and optimization recommendations. You can perform tasks such as the following:
  • Adjusting the Optimization Mode
  • Setting Automation and Power Management
  • Changing the Critical Thresholds
  • Tuning Metric Weightings
  • Excluding Hosts from Recommendations
  • Advanced Settings
Note: After connecting or reconnecting to Workload Balancing, wait at least sixty seconds (until the Workload Balancing (/var/log/wlb/LogFile.log) shows discovery is finished) before changing settings.

How Workload Balancing settings apply

Workload Balancing settings apply collectively to all virtual machines and hosts in the pool.

Provided the network and disk thresholds align with the hardware in your environment, you might want to consider using most of the defaults in Workload Balancing initially.

After Workload Balancing is enabled for a while, Citrix recommends evaluating your performance thresholds and determining if you need to edit them. For example, consider if you are:
  • Getting optimization recommendation when they are not yet required. If this is the case, try adjusting the thresholds until Workload Balancing begins providing suitable optimization recommendations.
  • Not getting recommendations when you think your network has insufficient bandwidth. If this is the case, try lowering the network critical thresholds until Workload Balancing begins providing optimization recommendations.

Before you edit your thresholds, you might find it handy to generate a Host Health History report for each physical host in the pool.

You can use either the Workload Balancing Configuration properties in XenCenter or the XE commands to modify the configuration settings.

To update the credentials XenServer and the Workload Balancing server use to communicate, see Updating Workload Balancing Credentials.

For more detailed guidance about tuning Workload Balancing settings, see the Workload Balancing Administrator's Guide.

To display the Workload Balancing Settings dialog box

  1. In the Resources pane of XenCenter, select your-resource-pool.
  2. In the Properties pane, click the WLB tab.
  3. In the WLB tab, click Settings.


Adjusting the Optimization Mode

Workload Balancing makes recommendations to rebalance, or optimize, the virtual machine workload in your environment based on a strategy for placement you select known as the optimization mode.

Maximum Density and Maximum Performance modes

You can select one of two optimization modes:
  • Maximize Performance. (Default.) Workload Balancing attempts to spread workload evenly across all physical hosts in a resource pool. The goal is to minimize CPU, memory, and network pressure for all hosts. When Maximize Performance is your placement strategy, Workload Balancing recommends optimization when a virtual machine reaches the High threshold.

  • Maximize Density. Workload Balancing attempts to fit as many virtual machines as possible onto a physical host. The goal is to minimize the number of physical hosts that must be online.

    When you select Maximize Density as your placement strategy, you can specify rules similar to the ones in Maximize Performance. However, Workload Balancing uses these rules to determine how it can pack virtual machines onto a host. When Maximize Density is your placement strategy, Workload Balancing recommends optimization when a virtual machine reaches the Critical threshold.

Workload Balancing also lets you apply these optimization modes all of the time, Fixed, or switch between modes for specified time periods, Scheduled.

Fixed

Fixed optimization modes set Workload Balancing to a specific optimization behavior - either to try to create the best performance or the highest density - at all times.

Scheduled

Scheduled optimization modes let you schedule for Workload Balancing to apply different optimization modes depending on the time of day. For example, you might want to configure Workload Balancing to optimize for performance during the day when you have users connected and then, to save energy, specify for Workload Balancing to optimize for Maximum Density at night.

When you configure Scheduled optimization modes, Workload Balancing automatically changes to the optimization mode at the beginning of the time period—day of the week and time—you specified.

To set an optimization mode for all time periods

  • Select the pool in the Resources pane, click the WLB tab, and then click Settings.
  • In the left pane, click Optimization Mode.
  • Select Fixed, and select one of these optimization modes:
    • Maximize Performance. (Default.) Attempts to spread workload evenly across all physical hosts in a resource pool. The goal is to minimize CPU, memory, and network pressure for all hosts.
    • Maximize Density. Attempts to fit as many virtual machines as possible onto a physical host. The goal is to minimize the number of physical hosts that must be online. (Note that Workload Balancing considers the performance of consolidated VMs and issues a recommendation to improve performance if a resource on a host reaches a Critical threshold.)

To specify times when the optimization mode will change automatically

  • Select the pool in the Resources pane, click on the WLB tab, and then click Settings.
  • In the left pane, click Optimization Mode.
  • Select Scheduled.
  • Click Add New to open the Optimization Mode Scheduler dialog box.
  • Select an optimization mode in the Change to list box:
    • Maximize Performance. Attempts to spread workload evenly across all physical hosts in a resource pool. The goal is to minimize CPU, memory, and network pressure for all hosts.
    • Maximize Density. Attempts to fit as many virtual machines as possible onto a physical host. The goal is to minimize the number of physical hosts that must be online.
  • Select the day of the week and the time when you want Workload Balancing to begin operating in this mode.
  • Create more scheduled mode changes (that is, "tasks") until you have the number you need. If you only schedule one task, Workload Balancing will switch to that mode and never switch back.
  • Click OK.

To delete or pause a scheduled optimization mode task

  1. Select the pool in the Resources pane, click on the WLB tab, and then click Settings.
  2. Click Optimization Mode.
  3. Select a scheduled task and click one of the following:
    • Delete the task permanently. Click the Delete button.
    • Stop the task from running temporarily. Right-click the task and click Disable.

    To re-enable a task, right click the task in the Scheduled Mode Changes list.

To edit a scheduled optimization mode task

  1. Select the pool in the Resources pane, click on the WLB tab, and then click Settings.
  2. Select a scheduled task.
  3. Click Edit.
  4. In the Change to box, select a different mode or make other changes as desired.


Optimizing and Managing Power Automatically

You can configure Workload Balancing to accept optimization recommendations automatically (Automation) and turn servers on or off automatically (Power Management).

Accepting Optimization Recommendations automatically

Workload Balancing lets you configure for it to accept optimization recommendations on your behalf and perform the optimization actions it recommends automatically. You can use this feature, which is known as Automation, to apply any recommendations automatically, including ones to improve performance or power down hosts. However, to power down hosts as virtual-machines usage drops, you must configure automation, power management, and Maximum Density mode.

By default, Workload Balancing does not accept optimizations automatically. You must enable Automation if you want Workload Balancing to accept recommendations automatically. If you do not, Workload Balancing still prompts you to accept recommendations manually.

Workload Balancing will not automatically apply recommendations to hosts or virtual machines if the recommendations conflict with High Availability settings. If a pool will become overcommitted by applying Workload Balancing optimization recommendations, XenCenter will prompt you whether or not you want to continue applying the recommendation. When Automation is enabled, Workload Balancing will not apply any power-management recommendations that exceed the number of host failures to tolerate in the High Availability plan.

It is possible to tweak how Workload Balancing applies recommendations in automated mode. For information, see Advanced Settings.

Enabling Power Management

The term power management refers to the ability to the turn the power on or off for physical hosts. In a Workload Balancing context, this term refers to powering hosts in a pool on or off based on the pool's total workload.

Configuring Workload Balancing power management on a host requires that:
  • The hardware for the host server has remote power on/off capabilities
  • The Host Power On feature is configured for the host
  • The host has been explicitly selected as a host to participate in (Workload Balancing) Power Management
In addition, if you want Workload Balancing to power off hosts automatically, you also need to configure:
  • Workload Balancing is configured to apply recommendations automatically
  • Workload Balancing is configured to apply Power Management recommendations automatically

When enabled and the pool is in Maximum Density mode, if Workload Balancing detects unused resources, it recommends powering off hosts until it eliminates all excess capacity in the pool. If Workload Balancing detects there is not sufficient host capacity in the pool to turn off servers, it recommends leaving the servers on until the pool's workload decreases enough to power off servers. When you configure Workload Balancing to power off extra servers automatically, it applies these recommendations automatically and, consequently, behaves in the same way.

When a host is set to participate in Power Management, Workload Balancing makes power-on/off recommendations as needed. If you turn on the option to apply Power Management recommendations automatically, you do so at the pool level. However, you can specify which hosts from the pool you want to participate in Power Management.

Understanding Power Management Behavior

Before Workload Balancing recommends powering hosts on or off, it selects the hosts to transfer virtual machines to (that is, to "fill"). It does so in the following order:
  1. Filling the pool master since it is the host that cannot be powered off.
  2. Filling the host with the most virtual machines.
  3. Filling subsequent hosts according to which hosts have the most virtual machines running.

When Workload Balancing fills the pool master, it does so assuming artificially low (internal) thresholds for the master. Workload Balancing uses these low thresholds as a buffer to prevent the pool master from being overloaded.

Workload Balancing fills hosts in this order to encourage density.

This illustration shows how, when consolidating VMs on hosts in Maximum Density mode, XenServer attempts to fill the pool master first, the most loaded server second, and the least loaded server third.

If Workload Balancing detects a performance issue while the pool is in Maximum Density mode, it attempts to address the issue by recommending migrating workloads among the powered-on hosts. If Workload Balancing cannot resolve the issue using this method, it attempts to power-on a host. (Workload Balancing determines which host(s) to power-on by applying the same criteria it would if the optimization mode was set to Maximum Performance.)

When Workload Balancing is running in Maximum Performance mode, Workload Balancing recommends powering on hosts until the resource utilization on all hosts in the pool falls below the High threshold.

If, while migrating one or more virtual machines, Workload Balancing determines that increasing capacity would benefit the pool's overall performance, it powers on hosts automatically or recommends doing so.
Important: Workload Balancing never recommends powering on a host unless Workload Balancing powered it off.

Designing Environments for Power Management and VM Consolidation

When you are planning a XenServer implementation and you intend to configure automatic VM consolidation and power management, consider your workload design. For example, you may want to:

  • Place Different Types of Workloads in Separate Pools. If you have an environment with distinct types of workloads (for example, user applications versus domain controllers) or types of applications that perform better with certain types of hardware, consider if you need to locate the virtual machines hosting these workloads in different pools.

    Because power management and VM consolidation are managed at the pool level, you should design pools so they contain workloads that you want consolidated at the same rate, factoring in considerations such as those discussed in the Advanced Settings topic.

  • Exclude Hosts from Workload Balancing. Some hosts may need to be on at all times. See Excluding Hosts from Recommendations for more information.

To apply optimization recommendations automatically

  1. In the Resources pane of XenCenter, select XenCenter > your-resource-pool.
  2. In the Properties pane, click the WLB tab.
  3. In the WLB tab, click Configure WLB.
  4. In the left pane, click Automation.
  5. Select one or more of the following check boxes:
    • Automatically apply Optimization recommendations. When you select this option, you do not need to accept optimization recommendations manually. Workload Balancing automatically accepts optimization and placement recommendations it makes.
    • Automatically apply Power Management recommendations. The behavior of this option varies according to the pool's optimization mode:
      • Maximum Performance Mode. When Automatically apply Power Management recommendations is enabled, Workload Balancing automatically powers on hosts when doing so improves host performance.
      • Maximum Density Mode. When Automatically apply Power Management recommendations is enabled, Workload Balancing automatically powers off hosts when resource utilization drops below the Low threshold (that is, Workload Balancing powers hosts off automatically during low usage periods).
  6. Do one of the following:
    • If you want to configure power management, click Automation/Power Management and proceed to the section below.
    • If you do not want to configure power management and you are finished configuring automation, click OK.

To select servers for power management

  1. In the Power Management section, select the hosts that you want Workload Balancing to power on and off automatically.
    Note: Selecting hosts for power management recommendations without selecting the Automatically apply Power Management recommendations check box results in Workload Balancing suggesting power management recommendations but not applying them automatically for you.
  2. Click OK. If none of the physical servers in the resource pool support remote power management, Workload Balancing displays the message, No hosts support Power Management


Changing the Critical Thresholds

This topic provides guidance about how to modify the default Critical thresholds and how values set for Critical threshold alter High, Medium, and Low thresholds.

This information is only provided for reference while changing thresholds. To understand the concepts discussed in this topic, it is important to read them in the fuller context of the information provided in the Workload Balancing Administrator's Guide.

Overview

When evaluating utilization, Workload Balancing compares its daily average to four thresholds: low, medium, high, and critical. After you specify (or accept the default) critical threshold, Workload Balancing sets the other thresholds relative to the critical threshold on a pool. You might want to change Critical thresholds as a way of controlling when optimization recommendations are triggered.

Workload Balancing evaluates CPU, Memory, Network Read, Network Write, Disk Read, and Disk Write utilization for physical hosts in a resource pool.

Workload Balancing determines whether to recommend relocating a workload and whether a physical host is suitable for a virtual-machine workload by evaluating:
  • Whether a resource's critical threshold is met on the physical host
  • (If the critical threshold is met) the importance assigned to a resource
Note: To prevent data from appearing artificially high, Workload Balancing evaluates the daily averages for a resource and smooths utilization spikes.

For more information, see the Workload Balancing Administrator's Guide.

Workload Balancing determines whether or not to produce recommendations based on if the averaged historical utilization for a resource violates its threshold. As discussed in the Workload Balancing Administrator's Guide, Workload Balancing recommendations are triggered when the High threshold in Maximum Performance mode or Low and Critical thresholds for Maximum Density mode are violated. After you specify a new Critical threshold for a resource, Workload Balancing resets the resource's other thresholds relative to the new Critical threshold. (To simplify the user interface, the Critical threshold is the only threshold you can change through XenCenter.)

Default settings for thresholds

The following table shows the default values for the Workload Balancing thresholds:
Setting | Default | High | Medium | Low
CPU Utilization | 90% | 76.5% | 45% | 22.5%
Free Memory | 51MB | 63.75MB | 510GB | 1020GB
Network Read | 25MB/sec | 21.25MB/sec | 12.5MB/sec | 6.25MB/sec
Network Write | 25MB/sec | 21.25MB/sec | 12.5MB/sec | 6.25MB/sec
Disk read | 25MB/sec | 21.25MB/sec | 12.5MB/sec | 6.25MB/sec
Disk write | 26MB/sec | 21.25MB/sec | 12.5MB/sec | 6.25MB/sec
To calculate the values for the High, Medium, and Low resource metrics, Workload Balancing multiplies the new value for the Critical threshold with the following factors:
  • High Threshold Factor: 0.85
  • Medium Threshold Factor: 0.50
  • Low Threshold Factor: 0.25
To calculate threshold values for free memory, Workload Balancing multiplies the Critical threshold with these factors:
  • High Threshold Factor: 1.25
  • Medium Threshold Factor: 10.0
  • Low Threshold Factor: 20.0

This means that if you increase, for example, the pool's Critical threshold for CPU Utilization to 95%, Workload Balancing automatically resets the High, Medium, and Low thresholds to 80.75%, 47.5%, and 23.75% respectively.

To perform this calculation for a specific threshold, multiply the factor for the threshold with the value you entered for the critical threshold for that resource:

High, Medium, or Low Threshold = Critical Threshold * Threshold Factor

For example, if you change the Critical threshold for Network Reads to 40MB/sec and you want to know its Low threshold, you multiply 40 by 0.25, which equals 10MB/sec. To obtain the Medium threshold, you multiple 40 by 0.50, and so on.

To prevent the pool master from becoming overloaded, Workload Balancing automatically sets the pool master's Critical Thresholds at lower values.

How other thresholds trigger recommendations

While the Critical threshold triggers many recommendations, other thresholds can also trigger recommendations, as follows:

High threshold.
  • Maximum Performance. Exceeding the High threshold triggers optimization recommendations to relocate a virtual machine to a host with lower resource utilization.
  • Maximum Density. Workload Balancing will not recommend placing a virtual machine on host if moving that virtual machine to the host will cause the utilization of any of the host's resources to exceed the High threshold value.
Low threshold.
  • Maximum Performance. Workload Balancing does not trigger recommendations from the Low threshold.

  • Maximum Density. When a metric value drops below the Low threshold, it signals Workload Balancing that hosts are being underutilized and triggers an optimization recommendation to consolidate virtual machines on fewer hosts. Workload Balancing continues to recommend moving virtual machines onto a host until the metric values for one of the host's resource reaches its High threshold.

    However, if after a virtual machine is relocated, a resource's utilization on the virtual machine's new host exceeds its Critical threshold, Workload Balancing will temporarily use an algorithm similar to the Maximum Performance load-balancing algorithm to find a new host for the virtual machines. Workload Balancing continues to use this algorithm to recommend moving virtual machines until resource utilization on hosts across the pool falls below the High threshold.

To change the critical thresholds

  1. Select the pool in the Resources pane, click on the WLB tab, and then click Settings.
  2. In the left pane, select Critical Thresholds.

  3. In Critical Thresholds page, accept or enter a new value in the Critical Thresholds boxes. Workload Balancing uses these thresholds when making virtual-machine placement and pool-optimization recommendations. Workload Balancing strives to keep resource utilization on a host below the critical values set.


Tuning Metric Weightings

Note: Before tuning metric weightings, Citrix recommends reading about the optimization and consolidation process in the Workload Balancing Administrator's Guide. The information in this help topic is a subset of the information in that guide and is only meant to be used as a reference when changing the user interface.

Workload Balancing uses metric weightings, a method of assigning importance to resources, to determine what hosts it should optimize first.

The way in which Workload Balancing uses metric weightings when determining which hosts and VMs to process first varies according to the optimization mode, Maximum Density or Maximum Performance.

When Workload Balancing is processing optimization recommendations, it creates an optimization order. To determine this, Workload Balancing ranks the hosts to address first according to which hosts have the highest metric values for whatever resource is ranked as the most important in the metric weightings page.

In general, metric weightings are mainly used when a pool is in Maximum Performance mode. However, when Workload Balancing is in Maximum Density mode, it does use metric weightings if a resource exceeds its Critical threshold.

How metric weightings apply in Maximum Performance mode

In Maximum Performance mode, Workload Balancing uses metric weightings to determine (a) which hosts' performance to address first and (b) which VMs to recommend migrating first.

For example, if you rank Network Writes as the most important resource for Workload Balancing to consider—that is, you move the Metric Weighting slider all the way to the right (More Important) and you move all the other sliders to the middle—then Workload Balancing will begin addressing performance issues (that is, making optimization recommendations) on the host with the highest number of Network Writes per second first.

How metric weightings apply in Maximum Density mode

In Maximum Density mode, Workload Balancing only uses metric weightings when a host reaches the Critical threshold—then Workload Balancing applies a Maximum Performance-like algorithm until no Hosts are exceeding the Critical thresholds. When using the Maximum Performance-like algorithm, Workload Balancing uses metric weightings to determine the optimization order in the same way as it does for Maximum Performance mode.

If two or more hosts have resource(s) exceeding their Critical thresholds, Workload Balancing verifies the importance you set for each resource before determining which host to optimize first and which VMs on that host to relocate first.

For example, your pool contains Host A and Host B, which are in the following state:
  • The CPU utilization on Host A exceeds the Critical threshold for CPU, and the metric weighting for CPU utilization is set to the far right of the slider (More Important).
  • The memory utilization on Host B exceeds the Critical threshold for memory, and the metric weighting for memory utilization is set to the far left of the slider (Less Important).

Workload Balancing will recommend optimizing Host A first because the resource on it that reached the Critical threshold is the resource assigned the highest weight. After Workload Balancing determines that it needs to address the performance on Host A, Workload Balancing then begins recommending placements for VMs on that host beginning with the VM that has the highest CPU utilization, since that CPU utilization is the resource with the highest weight.

After Workload Balancing has recommended optimizing Host A, it makes optimization recommendations for Host B. When it recommends placements for the VMs on Host B, it does so by addressing CPU utilization first, since CPU utilization was assigned the highest weight.

If there are additional hosts that need optimization, Workload Balancing addresses the performance on those hosts according to what host has the third highest CPU utilization.

By default, all metric weightings are set to the farthest point on the slider (More Important).
Note: The weighting of metrics is relative. This means that if all of the metrics are set to the same level, even if that level is Less Important, they will all be weighted the same. The relation of the metrics to each other is more important than the actual weight at which you set each metric.

To edit metric weighting factors

  1. Select the pool in the Resources pane, click on the WLB tab, and then click Settings.
  2. In the left pane, select Metric Weighting.
  3. In the Metric Weighting page, as desired, adjust the sliders beside the individual resources.

    Moving the slider towards Less Important indicates that ensuring virtual machines always have the highest amount of this resource available is not as vital on this resource pool.


Excluding Hosts from Recommendations

When configuring Workload Balancing, you can specify that specific physical hosts are excluded from Workload Balancing optimization and placement recommendations, including Start On placement recommendations.

When to exclude hosts

Situations when you may want to exclude hosts from recommendations include when:
  • You want to run the pool in Maximum Density mode and consolidate and shut down hosts, but there are specific hosts you want to exclude from this behavior.
  • When two virtual-machine workloads always need to run on the same host (for example, if they have complementary applications or workloads).
  • You have workloads that you do not want moved (for example, domain controllers or SQL Server).
  • You want to perform maintenance on a host and you do not want virtual machines placed on the host.
  • The performance of the workload is so critical that the cost of dedicated hardware is irrelevant.
  • Specific hosts are running high-priority workloads (virtual machines), and you do not want to use the High Availability feature to prioritize these virtual machines.
  • The hardware in the host is not the optimum for the other workloads in the pool.

Regardless of whether you specify a fixed or scheduled optimization mode, hosts excluded remain excluded even when the optimization mode changes. Therefore, if you only want to prevent Workload Balancing from powering down a host automatically, consider not enabling (or deselecting) Power Management for that host instead as described in Optimizing and Managing Power Automatically.

To exclude hosts from placement and optimization recommendations

  1. Select the pool in the Resources pane, click on the WLB tab, and then click Settings.
  2. In the left pane, select Excluded Hosts.
  3. In the Excluded Hosts page, select the hosts for which you do not want Workload Balancing to recommend alternate placements and optimizations.


Advanced Settings

The settings in the Advanced dialog primarily fine-tune the way in which Workload Balancing applies recommendations when it is running in automated mode.
Important:

After Workload Balancing is running for a period of time, if you do not receive optimal placement recommendations, Citrix strongly recommends you evaluate your performance thresholds as described in the Workload Balancing Administrator's Guide. It is critical to set Workload Balancing to the correct thresholds for your environment or its recommendations might not be appropriate.

Overview: Setting Conservative or Aggressive Automated Recommendations

When running in automated mode, the frequency of optimization and consolidation recommendations and how soon they are automatically applied is a product of multiple factors, including:
  • How long you specify Workload Balancing waits before applying another optimization recommendation
  • The number of recommendations Workload Balancing must make before applying a recommendation automatically
  • The severity level a recommendation must achieve before the optimization is applied automatically
  • The level of consistency in recommendations (recommended virtual machines to move, destination hosts) Workload Balancing requires before applying recommendations automatically

VM Migration Interval

You can specify the number of minutes Workload Balancing must wait after the last time a particular virtual machine was moved, regardless of the cause, before it can generate another optimization recommendation that includes that particular virtual machine.

The recommendation interval is designed to prevent Workload Balancing from generating recommendations for artificial reasons (for example, if there was a temporary utilization spike).

When Automation is configured, it is especially important to be careful when modifying the recommendation interval. If an issue occurs that leads to continuous, recurring spikes, increasing the frequency (that is, setting a lower number) can generate many recommendations and, consequently, relocations.
Note: Setting a recommendation interval does not affect how long Workload Balancing waits to factor recently rebalanced servers into recommendations for Start-On Placement, Resume, and Maintenance Mode.

Recommendation Count

Every two minutes, Workload Balancing checks to see if it can generate recommendations for the pool it is monitoring. When you enable Automation, you can specify the number of times a consistent recommendation must be made before Workload Balancing can automatically apply the recommendation. To do so, you configure a setting known as the Recommendation Count. The Recommendation Count and the Optimization Aggressiveness setting let you fine-tune the automated application of recommendations in your environment.

As described in the overview section, Workload Balancing uses the similarity of recommendations to a) vet if the recommendation is truly needed and b) determine if the destination host has stable enough performance over a prolonged period of time to accept a relocated virtual machine (without needing to move it off the host again shortly). Workload Balancing uses the Recommendation Count value to determine a recommendation must be repeated before Workload Balancing automatically applies the recommendation.

Workload Balancing uses this setting as follows:
  1. Every time Workload Balancing generates a recommendation that meets its consistency requirements, as indicated by the Optimization Aggressiveness setting, Workload Balancing increments the Recommendation Count. If the recommendation does not meet the consistency requirements, Workload Balancing may reset the Recommendation Count to zero, depending on the factors described in the Workload Balancing Administrator's Guide.
  2. When Workload Balancing generates enough consistent recommendations to meet the value for the Recommendation Count, as specified in the Recommendations text box, it automatically applies the recommendation.
If you choose to modify this setting, the value you should set varies according to your environment. Consider these scenarios:
  • If server loads and activity increase extremely quickly in your environment, you may want to increase value for the Recommendation Count. Workload Balancing generates recommendations every two minutes. For example, if you set this interval to "3", then six minutes later Workload Balancing applies the recommendation automatically.
  • If server loads and activity increase gradually in your environment, you may want to decrease the value for the Recommendation Count.

Accepting recommendations uses system resources and affects performance when Workload Balancing is relocating the virtual machines. Increasing the Recommendation Count increases the number of matching recommendations that must occur before Workload Balancing applies the recommendation, which encourages Workload Balancing to apply more conservative, stable recommendations and may decrease the potential for spurious virtual machine moves. It should be noted, however, that the Recommendation Count is set to a conservative value by default.

Because of the potential impact adjusting this setting may have on your environment, Citrix only recommends changing it with extreme caution, preferably by testing and iteratively changing the value or under the guidance of Citrix Technical Support.

Recommendation Severity

All optimization recommendations include a severity rating (Critical, High, Medium, Low) that indicates the importance of the recommendation. Workload Balancing bases this rating on a combination of factors including configuration options you set, such as thresholds and metric tunings; resources available for the workload; and resource-usage history.

When you configure Workload Balancing to apply optimization recommendations automatically, you can set the minimum severity level that should be associated with a recommendation before Workload Balancing automatically applies it.

Optimization Aggressiveness

To provide additional assurance when running in automated mode, Workload Balancing has consistency criteria for accepting optimizations automatically so as to prevent moving virtual machines due to spikes and anomalies. In automated mode, Workload Balancing does not accept the first recommendation it produces. Instead, Workload Balancing waits to automatically apply a recommendation until a host or virtual machine exhibits consistent behavior over time. The phrase consistent behavior over time refers to factors such as whether a host continues to trigger recommendations and whether the same virtual machines on that host continue to trigger recommendations.

Workload Balancing determines if behavior is consistent by using criteria for consistency and by having criteria for the number of times the same recommendation is made (that is, the Recommendation Count). You can configure how strictly you want Workload Balancing to apply the consistency criteria using a Optimization Aggressiveness setting.

While Citrix primarily designed the Optimization Aggressiveness setting for demonstration purposes, you can use this setting to control the amount of stability you want in your environment before Workload Balancing applies an optimization recommendation. The most stable setting (Low aggressiveness) is configured by default. In this context, the term stable refers to the similarity of the recommended changes over time, as explained throughout this section.

Workload Balancing uses up to four criteria to ascertain consistency. The number of criteria that must be met varies according to the level you set in the Optimization Aggressiveness setting. The lower the level (for example, Low or Medium) the less aggressively Workload Balancing is in accepting a recommendation. In other words, Workload Balancing is stricter about requiring criteria to match (or less cavalier or aggressive) about consistency when aggressiveness is set to Low.

For example, if the aggressiveness level is set to Low, Workload Balancing requires that each criterion for Low is met the number of times specified in the Recommendations box (where you specify the Recommendation Count value) before automatically applying the recommendation.

For example, if you set the Recommendation Count in the Recommendations box to "3", you are making Workload Balancing wait until it sees all the criteria listed in the Workload Balancing Administrator's Guide for Low are met and repeated in three consecutive recommendations. This helps ensure that the virtual machine actually needs to be moved and that the destination host Workload Balancing is recommending has consistently stable resource utilization over a longer period of time. It reduces the potential for a recently moved virtual machine to be moved off a host due to host performance changes after the move. By default, this setting is set to a conservative setting (Low) to encourage stability.

Citrix does not recommend increasing the Optimization Aggressiveness to increase the frequency with which your hosts are being optimized. If you feel that your hosts are not being optimized quickly or frequently enough, try adjusting the Critical thresholds, as described in Changing the Critical Thresholds.

For details about the consistency criteria associated with the different levels of aggressiveness, see the Workload Balancing Administrator's Guide.

If you find that Workload Balancing is not automatically applying optimization recommendations frequently enough, you might want to increase the aggressiveness setting. However, Citrix strongly recommends reviewing the information in the Workload Balancing Administrator's Guide before doing so.

To configure virtual machine recommendation intervals

  1. Select the pool in the Resources pane, click on the WLB tab, and then click Settings.
  2. In the left pane, click Advanced.
  3. In the VM Recommendation Interval section, do one or more of the following:

    - In the Minutes box, type a value for the number of minutes you want Workload Balancing to wait before making another optimization recommendation on a newly rebalanced server.

    - In the Recommendations box, type a value for the number of optimization recommendations you want Workload Balancing to make before it applies an optimization recommendation automatically.

    - Select a minimum severity level before optimizations are applied automatically.

    - Modify how aggressively Workload Balancing automatically applies optimization recommendations.


Administering Workload Balancing

Some administrative tasks you may want to perform on Workload Balancing include:
  • Disconnecting from Workload Balancing
  • Changing the Workload Balancing virtual appliance that a pool uses
  • Changing the credentials Workload Balancing or XenServer use to communicate
You can also administer the Workload Balancing virtual appliance using the Workload Balancing service commands. These commands let you determine Workload Balancing virtual appliance status, change user accounts, and increase logging detail. For information about these commands, see the Workload Balancing Administrator's Guide.
Note: For information about configuring Workload Balancing to use a different certificate or configuring XenServer to verify the identity of a certificate, see the Workload Balancing Administrator's Guide.


Disconnecting from Workload Balancing

If you want to stop Workload Balancing from monitoring your pool, you must disable Workload Balancing on the pool by disconnecting the Workload Balancing server.

When you disconnect a pool from the Workload Balancing virtual appliance, Workload Balancing permanently deletes information about the pool from the Workload Balancing database and stops collecting data for that pool. This means that if you want to use the same Workload Balancing virtual appliance to manage the pool again, you must re-enter the appliance's information in the Connect to WLB Server dialog box.
Important: If you only want to stop Workload Balancing temporarily, click the WLB tab and click the Pause button.

To disconnect from Workload Balancing

  1. In the Resource pane of XenCenter, select the resource pool on which you want to stop Workload Balancing.
  2. From the Pool menu, select Disconnect Workload Balancing Server. The Disconnect Workload Balancing dialog box appears.
  3. Click Disconnect to stop Workload Balancing from monitoring the pool.
    Note: If you disconnected the pool from the Workload Balancing virtual appliance, to re-enable Workload Balancing on that pool, you must reconnect to the appliance.


Reconfiguring a Pool to Use Another WLB Appliance

You can reconfigure a pool to use a different Workload Balancing virtual appliance.

However, to prevent the old Workload Balancing appliance from inadvertently remaining configured and collecting data for the pool, you must disconnect the pool from the old Workload Balancing appliance before connecting the pool to the new Workload Balancing appliance.

Once the pool is disconnected from the old Workload Balancing appliance, reconnect the pool by specifying the new Workload Balancing appliance name.

To use a different Workload Balancing appliance

  1. On the pool you want to use a different Workload Balancing appliance, from the Pool menu, select Disconnect Workload Balancing Server and click Disconnect when prompted. For instructions, see Disconnecting from Workload Balancing.
  2. In the WLB tab, click Connect. The Connect to WLB Server dialog appears.
  3. In the Address box, type the IP address or host name (FQDN) name of the new Workload Balancing appliance.
    If the new Workload Balancing appliance uses different credentials, you must also enter the new credentials.
    Note: You must enter all the information that you would normally enter when you initially connect a pool to Workload Balancing. For information, see Connecting to Workload Balancing.


Updating Workload Balancing credentials

After initial configuration, if you need to update the credentials XenServer and the Workload Balancing appliance use to communicate, you can do so using a three-step process:
  1. Disconnect from Workload Balancing, as described below.
  2. Change the WLB credentials by editing the WlbConfig file (run the WlbConfig command in the console on the Workload Balancing virtual appliance). See the Workload Balancing Administrator's Guide for details.
  3. Reenable Workload Balancing and specify the new credentials, as described below.
Situations when you may want to use these steps include:
  • If you need to change the user account XenServer uses to communicate with Workload Balancing
  • If you receive an error message that the Workload Balancing credentials are no longer valid
  • If the service is unavailable

If you want to modify settings for thresholds and change the priority given to specific resources, see Editing Workload Balancing Settings.

To disconnect from Workload Balancing

  1. In the Resource pane of XenCenter, select the resource pool on which you want to stop Workload Balancing.
  2. From the Pool menu, select Disconnect Workload Balancing Server. The Disconnect Workload Balancing dialog box appears.
  3. Click Disconnect to permanently stop Workload Balancing from monitoring the pool.

To reenable Workload Balancing and specify the new credentials

  1. After the progress bar completes, click Connect. The Connect to WLB Server dialog box appears.
  2. Click Update Credentials.
  3. In the Server Address section, modify the following as desired:
    • In the Address box, type the IP address or FQDN of the Workload Balancing appliance.
    • (Optional.) If you changed the port number during Workload Balancing Configuration, enter that port number. The port number you specify in this box and during Workload Balancing Configuration is the port number XenServer uses to connect to Workload Balancing.
      By default, XenServer connects to Workload Balancing on port 8012.
      Note: Do not edit this port number unless you have changed it during Workload Balancing Setup. The port number value specified during Setup and in the Workload Balancing Configuration dialog must match.
  4. In the WLB Server Credentials section, enter the user name (for example, wlbuser) and password the computers running XenServer will use to connect to the Workload Balancing server.
  5. In the XenServer Credentials section, enter the user name and password for the pool you are configuring (typically the password for the pool master). Workload Balancing will use these credentials to connect to the computers running XenServer in that pool. To use the credentials with which you are currently logged into XenServer, select the Use the current XenCenter credentials check box.


Entering Maintenance Mode with Workload Balancing Enabled

When Workload Balancing is enabled, if you take a physical host offline for maintenance (that is, suspend a server by entering Maintenance Mode), XenServer automatically migrates the virtual machines running on that host to their optimal servers when available. XenServer migrates them based on Workload Balancing recommendations (performance data, your placement strategy, and performance thresholds).

If an optimal server is not available, the words Click here to suspend the VM appear in the Enter Maintenance Mode dialog box. In this case, Workload Balancing does not recommend a placement because no host has sufficient resources to run this virtual machine. You can either suspend this virtual machine or exit Maintenance Mode and suspend a virtual machine on another host in the same pool. Then, if you reenter the Enter Maintenance Mode dialog box, Workload Balancing might be able to list a host that is a suitable candidate for migration.
Note: When you take a server offline for maintenance and Workload Balancing is enabled, the words "Workload Balancing" appear in the upper-right corner of the Enter Maintenance Mode dialog box.

To enter maintenance mode with Workload Balancing enabled

  1. In the Resources pane, select the server and then do one of the following:
    • Right-click and click Enter Maintenance Mode on the shortcut menu.
    • On the Server menu, click Enter Maintenance Mode.
  2. Click Enter Maintenance Mode. The virtual machines running on the server are automatically migrated to the optimal host based on Workload Balancing's performance data, your placement strategy, and performance thresholds.

To take the server out of maintenance mode

  1. In the Resources pane, select the server and then do one of the following:
    • Right-click and click Exit Maintenance Mode on the shortcut menu.
    • On the Server menu, click Exit Maintenance Mode.
  2. Click Exit Maintenance Mode.

    When you remove a server from maintenance mode, XenServer automatically restores that server's original virtual machines to that server.


Troubleshooting Workload Balancing

While Workload Balancing usually runs smoothly, this help system provides a series of topics with guidance in case you encounter issues. Additional troubleshooting topics are provided in the Workload Balancing Administrator's Guide.

Here are a few tips for resolving general Workload Balancing issues:

General Troubleshooting Tips

Start troubleshooting by reviewing the Workload Balancing log. You can find the log in Workload Balancing appliance in this location (by default):

/var/log/wlb

Also, check the logs in the XenCenter Logs tab for more (different) information.

Error Messages

Workload Balancing displays error messages in the Log tab in XenCenter and, in some cases, on screen as dialog boxes.


Issues Entering Workload Balancing Credentials

If you cannot get Workload Balancing to accept the appliance user account and password when configuring the Connect to WLB Server dialog, try the following:
  • Make sure that Workload Balancing appliance imported and was configured correctly and all of its services are running by running the service workloadbalancing start command.
  • Using Issues Starting Workload Balancing as a guide, check to make sure you are entering the correct credentials.
  • Enter the Workload Balancing server's IP address if you are having trouble entering the Workload Balancing FQDN.

You can enter the host name of the Workload Balancing appliance in the Address box, but it must be a fully qualified domain name (FQDN). For example, yourcomputername.yourdomain.net.


Issues Starting Workload Balancing

If after importing and configuring the Workload Balancing appliance, you receive an error message that XenServer and Workload Balancing cannot connect to each other, you might have entered the incorrect credentials in the Connect to WLB Server dialog. To isolate this issue, try:
  • Verifying the credentials you entered in the Connect to WLB Server dialog match the credentials that you created on the Workload Balancing server and on XenServer
  • Verifying the IP address or FQDN of the Workload Balancing appliance you entered in the Connect to WLB Server dialog is correct.
  • Verifying the account credentials for the Workload Balancing account you created during Workload Balancing Configuration match the credentials you entered in the Connect to WLB Server dialog.


Workload Balancing Connection Errors

If you receive a connection error in the Workload Balancing Status line on the WLB tab, you might need to reconfigure Workload Balancing on that resource pool.

Click the Connect button on the WLB tab and enter the server credentials again.

Typical causes for this error include changing the credentials of the WLB virtual appliance or pool master or changing the name of the WLB virtual appliance.


Issues changing Workload Balancing servers

If you connect a resource pool to a different Workload Balancing virtual appliance without first disconnecting the pool from the original Workload Balancing appliance, both the old and new Workload Balancing appliances will monitor the pool.

To solve this problem, you can either shut down and delete the old Workload Balancing appliance or manually stop the Workload Balancing services (analysis, data collector and Web service) so that the appliance no longer monitors the pool.

Citrix does not recommend using the pool-initialize-wlb xe command to remove or change Workload Balancing server configuration.


About XenServer Licensing

XenServer uses the same licensing process as other Citrix products. XenServer requires a License Server. For details on how to install and run Citrix Licensing, see Citrix eDocs website.

After purchasing support for XenServer you will be provided with .LIC license key. This license key should be installed on either:

  • a Windows server running the Citrix License Server software
  • a Linux-based Citrix License Server virtual appliance

XenServer Licensing is dependent upon the installed version.

  • For information about managing licenses in XenServer v6.2.0, see Licensing Overview (XenServer v6.2.0).
  • For information about managing licenses in XenServer v6.1.0 and earlier, see Licensing Overview (XenServer v6.1.0 and earlier).


Managing Licenses in XenServer v6.2.0

This topic contains information about managing licenses in XenServer version 6.2.0. For information about managing licenses prior to XenServer 6.2.0, see Managing Licenses in XenServer 6.1.0 and earlier.

When you install XenServer it starts in an unlicensed state. When it is unlicensed, there are no restrictions on its functionality or features, with the exception of the application of hotfixes. In order to receive Citrix Support, XenServer hosts must be licensed.

XenServer hosts are licensed on a per-populated socket basis and all hosts in a pool must be licensed. Mixed pools of licensed and unlicensed hosts will behave as if all hosts were unlicensed.

To assign a XenServer license

  1. On the Tools menu, click License Manager.
  2. Select the host(s) or pool(s) that you wish to assign a license and then click Assign License.
  3. In the Apply License dialog, select the type of license you want to request from the license server:
    • Citrix XenServer Per-Socket: Select this option to activate the per-populated socket licensing model. This license type is applicable for XenServer version 6.2.0 and higher.
    • Citrix XenServer for XenDesktop: Select this option to request an existing Citrix XenServer for XenDesktop license from the license server.
  4. Enter the license server details and then click OK.
    Note: By default, the License Server uses port 27000 for communication with Citrix products. If you changed the default port on the License Server, enter the appropriate number in the Port number box. For more information about changing port numbers due to conflicts, see the Licensing Your Product topic on Citrix eDocs.

XenCenter contacts the specified Citrix V6 license server and requests a license for the specified server(s). If successful, a license is checked out and the information shown in the XenCenter License Manager will be updated. If the license server cannot be contacted, then the server lapses into a 30-day licensing grace period.

Note: When requesting or applying licenses, information about the XenServer version and license type may be transmitted to Citrix. No other information relating to any users of the system, virtual machines running in the environment, or the environment in which XenServer is deployed, is collected or transmitted to Citrix. The limited information transmitted to Citrix during the licensing process is handled in accordance with the Citrix privacy policy, a copy of which can be reviewed at http://www.citrix.com/privacy.

Upgrading to XenServer 6.2.0 from the Free edition

After upgrading to XenServer 6.2.0 host or pool from the Free edition, you will have an unlicensed, but fully functional edition of XenServer. However, XenCenter displays its status as Unsupported and you will be unable to apply hotfixes or other updates using XenCenter. If you choose to purchase a license, as soon as you assign the host or pool a new license, its status will display as Licensed, and the License Type will show as Citrix XenServer Per-Socket Edition.

Upgrading to XenServer 6.2.0 from either an Advanced, Enterprise, or Platinum Edition

After upgrading to XenServer 6.2.0 host or pool from a paid-for edition, you will have an unlicensed, but fully functional edition of XenServer. However, XenCenter displays its status as Unsupported and you will be unable to apply hotfixes or updates using XenCenter. In such cases, you will need to:

  1. Trade-in your existing per-host license for a per-socket license
  2. Add the new license file to your License Server
  3. Apply the license to your XenServer host or pool

After applying the license, your host or pool will display as Licensed, and the License Type will show as Citrix XenServer Per-Socket Edition.

To release a XenServer license

  1. On the Tools menu, click License Manager.
  2. Select the host(s) or pool(s) and then click Release License.


Managing Licenses in XenServer 6.1.0 and earlier

XenServer Advanced, Enterprise and Platinum Editions share the same licensing model as other Citrix products, and each host server requires a license to be installed on to a separate Citrix Licensing Server. For details on how to install and run Citrix Licensing, see Citrix eDocs website.

For information about managing licenses in XenServer version 6.2.0, see Managing Licenses in XenServer v6.2.0.

You can manage your XenServer Advanced, Enterprise and Platinum Editions licenses from XenCenter using License Manager: on the Tools menu, click License Manager. Via the License Manager, you can:

  • Assign XenServer licenses to managed servers. When you assign a license, XenCenter contacts the Citrix license server and requests the specified type of license. If a license is available, it is then checked out from the license server.
  • Release XenServer licenses. When you release a license, XenCenter contacts the Citrix license server and checks the license back in.

Each host server in a XenServer resource pool must be individually licensed. For example, if you are supporting four XenServer hosts in a resource pool, you must assign a license to each of the four hosts. While it is possible to mix different editions of XenServer hosts in the same pool, it is important to note that the host with the lowest license determines the features available to all members in the pool. For example, a pool with a mixture of Advanced and Platinum Edition hosts only has the Advanced features enabled. Therefore, if you change a host to use a lower level of license, you can effectively disable features in the pool.

To assign a XenServer license

  1. Open the License Manager: on the Tools menu, click License Manager.
  2. Select one or more servers and then click Assign License.
  3. In the Assign License dialog, select the type of license you want to request from the license server:
    • Citrix XenServer Advanced Edition: This license activates specific administration features within XenCenter, including High Availability (HA), VM Protection and Recovery (VMPR), Dynamic Memory Control, real-time alerts and historical reports on VM performance.
    • Citrix XenServer Enterprise Edition: This license adds automated Workload Balancing and StorageLink for integration with your existing storage infrastructure to the features available in Advanced edition.
    • Citrix XenServer Platinum Edition: This license activates features whose administration is performed outside of XenCenter, such as Provisioning Services and Lab Management. A license for Lab Management and Stage Management is provided as a separate download from My Account at citrix.com along with the Citrix Lab Manager installation ISO; Lab Management licenses are applied from within the Lab Manager management console.
    • Citrix XenServer for XenDesktop: Select this option to request an existing Citrix XenServer for XenDesktop license from the license server. This allows you to use XenServer Enterprise to host Desktop VMs and all XenDesktop Infrastructure VMs as needed, including XenDesktop hosts and XenApp hosts.
  4. Enter the license server details and then click OK.

XenCenter contacts the specified Citrix V6 license server and requests a license for the specified server(s). If successful, a license is checked out and the information shown in the XenCenter License Manager will be updated. If the license server cannot be contacted, then the server lapses into a 30-day licensing grace period.

Note: When activating a free XenServer product or requesting/applying license to paid-for Editions, information about the XenServer server version and license type may be transmitted to Citrix. No other information relating to any users of the system, virtual machines running in the environment, or the environment in which XenServer is deployed, is collected or transmitted to Citrix. The limited information transmitted to Citrix during the licensing process is handled in accordance with the Citrix privacy policy, a copy of which can be reviewed at http://www.citrix.com/privacy.

To release a XenServer license

  1. Open the License Manager: on the Tools menu, click License Manager.
  2. Select a server and then click Release License.


Activate a Free XenServer Product

To activate a free XenServer product, you need to apply an activation key (this may also be referred to as "license key" in some places) to the host server. The activation process works like this:

  1. You request an activation key from Citrix. An activation key file license.xslic will then be emailed to you.
  2. You apply the activation key to the server running the free XenServer product that you wish to activate.

You can apply an activation key by simply double-clicking on the key file in Windows Explorer and then selecting the server to which you want to apply it, or from within XenCenter using the License Manager.

Note: When activating a free XenServer product, information about the XenServer server version and license type may be transmitted to Citrix. No other information relating to any users of the system, virtual machines running in the environment, or the environment in which XenServer is deployed, is collected or transmitted to Citrix. The limited information transmitted to Citrix during the licensing process is handled in accordance with the Citrix privacy policy, a copy of which can be reviewed at http://www.citrix.com/privacy.

To request an activation key

  1. Open the License Manager: on the Tools menu, click License Manager.
  2. Select one or more servers running the free XenServer product, click on Activate Free XenServer and then click Request Activation Key.

    A web browser will open and you will be taken to the Citrix XenServer activation web page where the activation details of the servers you selected are recorded and where you need to fill in your contact information and email address.

    If XenCenter is unable to connect to the XenServer activation server, you will be asked if you want to save the activation details of the selected host servers to a file. You will then be able to import this file to the XenServer activation server later, once your internet connection is restored.

When you have completed the activation form, an activation key file for each of the free XenServer products you selected will be emailed to you. For example:

You then need to apply the appropriate key file to each of your XenServer hosts in order to activate them.

To apply an activation key in XenCenter

Before you start, make sure that the activation key file can be accessed from the machine where you are running XenCenter and that you have connected to (added) the relevant servers to the set of managed resources.

  1. Open the License Manager : on the Tools menu, click License Manager.
  2. Select the server running the free XenServer product, click Activate Free XenServer and then click Apply an Activation Key.
  3. Locate the activation key file (license.xslic) and then click Open.

To apply an activation key from a key file

  1. Locate the activation key file (license.xslic) in Windows Explorer and then double-click it.
  2. In the Apply Activation Key dialog box, select the server running the free XenServer product that you wish to activate and then click Apply.


Licensing Overview (XenServer v6.1.0 and earlier)

Note: If you are running XenServer version 6.2.0, see Licensing Overview (XenServer v6.2.0).

Citrix XenServer Free Edition is available to use at no cost and contains all the features needed to create a virtual infrastructure. The XenServer Free Edition is available for free production use with no restrictions or time limits; all you need to do is activate the product within 30 days of first installing it to register your intent to use it with Citrix. Activation is a simple process that takes only a few minutes. For information about activating XenServer Free Edition, see Activate a Free XenServer Product.

Three paid-for XenServer Editions — Advanced, Enterprise and Platinum — provide a set of management and automation capabilities that extend the capabilities of the free Citrix XenServer platform. For information about the features available in different XenServer Editions, click here.

Citrix Licensing

All paid editions of the product use Citrix centralized licensing, and you must allocate licenses using a Citrix License Server, just as with other Citrix components. All XenServer Editions licenses must be installed on to a separate Citrix Licensing Server, and maintained and controlled using the Citrix License Management Console. In this way, XenServer shares the same licensing model as other Citrix products, and the licensing server can be shared across other Citrix products. For details of how to install and run Citrix Licensing, look at the online documentation on the Citrix eDocs website.

For information about managing licenses, see Managing Licenses in XenServer 6.1.0 and earlier.

License grace period

Citrix V6 licensing has built-in timeout technology. If a XenServer host cannot contact the license server, for example, due to problems with the license server hardware or software or network failures, there is a 30 day grace period that allows XenServer hosts to continue operations as if they were still in communication with the license server. After a startup license is checked out by a XenServer host, the XenServer and the license server exchange "heartbeat" messages every five minutes to indicate to each other that they are still up and running. If XenServer and the license server fail to send or receive heartbeats, XenServer lapses into the licensing grace period and licenses itself through cached information. The grace period is 30 days and when the grace period runs out, XenServer stops accepting connections. After communication is re-established between XenServer and the license server, the grace period is reset. The grace period takes place only if the XenServer has successfully communicated with the license server at least once.

Privacy

When activating a free XenServer product or requesting/applying licenses to paid-for Editions, information about the XenServer server version and license type may be transmitted to Citrix. No other information relating to any users of the system, virtual machines running in the environment, or the environment in which XenServer is deployed, is collected or transmitted to Citrix. The limited information transmitted to Citrix during the licensing process is handled in accordance with the Citrix privacy policy, a copy of which can be reviewed at http://www.citrix.com/privacy.


Licensing Overview (XenServer v6.2.0)

Note: If you are running XenServer version 6.1.0 or earlier, see Licensing Overview (XenServer v6.1.0 and earlier).

When you install XenServer, it starts in an unlicensed state. When it is unlicensed, there are no restrictions on its functionality or features, with the exception of the application of hotfixes. In order to receive Citrix Support, XenServer hosts must be licensed.

XenServer hosts are licensed on a per-populated socket basis and all hosts in a pool must be licensed. Mixed pools of licensed and unlicensed hosts will behave as if all hosts were unlicensed. For information on managing licenses in XenServer v6.2.0, see Managing Licenses in XenServer v6.2.0.

Licensing XenServer Editions

XenServer uses the same licensing process as other Citrix products. XenServer requires a License Server. After purchasing support for XenServer you will be provided with .LIC license key. This license key should be installed on either:
  • a Windows server running the Citrix License Server software
  • a Linux-based Citrix License Server virtual appliance
Important: XenServer Per-Socket Edition 6.2 requires Citrix License Server 11.6.1 or higher.

License Expiry

On expiry of a XenServer Per-Socket License edition:

  • the edition will revert to a fully functional but unlicensed XenServer
  • XenCenter will display it as Citrix XenServer Per-Socket Edition Expired
  • you will be unable to apply hotfixes or other updates using XenCenter
  • you will no longer be able to receive Citrix Technical Support for this host or pool, unless you purchase another license

License grace period

Citrix V6 licensing has built-in timeout technology. If a XenServer host cannot contact the license server, for example, due to problems with the license server hardware or software or network failures, there is a 30 day grace period that allows XenServer hosts to continue operations as if they were still in communication with the license server. After a startup license is checked out by a XenServer host, the XenServer and the license server exchange "heartbeat" messages every five minutes to indicate to each other that they are still up and running. If XenServer and the license server fail to send or receive heartbeats, XenServer lapses into the licensing grace period and licenses itself through cached information. The grace period is 30 days and when the grace period runs out, XenServer stops accepting connections. After communication is re-established between XenServer and the license server, the grace period is reset. The grace period takes place only if the XenServer has successfully communicated with the license server at least once.


Assign roles to users and groups

All XenServer users must have an RBAC role. In XenServer v6.2.0, you must first assign a role to the newly created user before they can use the account. Note that XenServer does not automatically assign a role to the newly created user. As a result, these accounts will not have any access to the XenServer pool until you assign them a role.

Assigning roles to users in XenServer v6.1.0 and earlier

In XenServer v6.1.0 and earlier, when new users are added, they are automatically assigned the Pool Administrator role. In XenServer Enterprise and higher, when you add new users, XenServer does not assign newly added user accounts roles automatically. You must assign roles to new accounts separately.

Note: Before you can assign a role to a user or group, you must add the user or group's Active Directory account to XenServer after joining the associated domain as described in Join a domain and add RBAC users.

You can assign a user a different role by one of the following methods:

  1. Change the role assigned to the user in the Select Roles dialog in XenCenter. This requires the Assign/modify role permission, which is only available to a Pool Administrator.
  2. Modify the user's containing group membership in Active Directory (so that the user becomes part of a group that is assigned a different role).

If, on separate occasions, an administrator indirectly applies multiple roles to a user (for example, by the user being a member of multiple groups), XenServer grants the user the permissions from the highest role to which he or she was assigned.

To change or assign a role to a user or group

  1. In the Resources pane, select the pool or server that contains the user or group.
  2. Click the Users tab.
  3. In the Users and Groups with Access pane, select the user or group to which you want to assign permissions.
  4. Click Change Role.
  5. In the Select Roles dialog, select the role you want to apply and click Save. For information about the permissions associated with each role, see Definitions of RBAC roles and permissions.
    Tip: When you are assigning a role, you can select multiple users simultaneously by pressing the CTRL key and selecting the user accounts.
  6. (Optional.) When changing a role, if the user is currently logged on to the pool and you want them to receive their new permissions immediately, click Logout User. This disconnects all of the user's sessions on the pool so the user receives a new session with the modified role.
    Note: When changing a role, for the new role to take effect, the user must log out and log back in again. You can force this log out by clicking the Logout User button. (Forcing logouts requires the Logout active user connections permission, which is available to a Pool Administrator or Pool Operator).


Audit changes

The XenServer audit log, which is enabled in XenServer by default, records any operation with side-effects (successful or unsuccessful) performed by a known user. This includes:

  • The user's name who performed the action. If the user's name is not available, XenServer logs the user ID instead.
  • The server name that was targeted by the action.
  • The status of the action - if it was successful or unsuccessful and if it was authorized. if the operation failed then the error code is logged.

The audit logging feature is enabled by default. The audit log can be backed up by using the XenServer syslog command to duplicate the audit log to a safe box. The syslog command is available from the CLI and documented in XenServer Administrator's Guide.

While Citrix strongly recommends that customers concerned with auditing implement Role Based Access Control, the audit log itself does not require that users be assigned RBAC roles nor does it require Active Directory integration.

XenServer logs actions on the pool level, and creates a log for each pool on the pool master.

To display the audit log, you have two choices. You can:

  • Generate the Pool Audit Trail report, provided you have Workload Balancing enabled.
  • Display the audit log by opening it in any text editor. The log is stored on the pool master.


Calculating RBAC roles

When I log in, how does XenServer compute the roles for the session?

  1. The Active Directory server authenticates the subject. During authentication, Active Directory also determines if the subject belongs to any other containing groups in Active Directory.
  2. XenServer then verifies which roles have been assigned to (a) the subject and (b) to any Active Directory groups to which it is a member.
  3. XenServer applies the highest level of permissions to the subject. Because subjects can be members of multiple Active Directory groups, they will inherit all of the permissions of the associated roles.

In this illustration, since Subject 2 (Group 2) is the Pool Operator and User 1 is a member of Group 2, when Subject 3 (User 1) tries to log in, he or she inherits both Subject 3 (VM Operator) and Group 2 (Pool Operator) roles. Since the Pool Operator role is higher, the resulting role for Subject 3 (User 1) is Pool Operator and not VM Operator.


Join a domain and add users

Before you can assign a user or group account an RBAC role, you must add the account to XenServer through RBAC. This requires two tasks:

  1. Join the pool or server to the domain. The domain can be either the domain in which the user or group belongs or a domain that is in the same Active Directory forest or that has a trust relationship with the user's domain.
  2. Add the user's Active Directory account or group to XenServer.

After adding the user's Active Directory account or group to XenServer, in both the free XenServer product and in XenServer Advanced, the user is automatically assigned a fixed role of Pool Admin. In XenServer Enterprise and higher, you must assign a role to the user or group manually.

To change domains, leave the current domain and then join the new domain.

To join the XenServer or pool to a domain

  1. In the Resources Pane, select the pool or server for which you want to grant somebody permissions.
  2. Click the Users tab.
  3. Click Join Domain.
  4. Enter Active Directory credentials with sufficient privileges to add servers to the domain you want to join. The domain to be joined must be specified as a fully qualified domain name (FQDN) rather than a NetBIOS name. For example, enter your_domain.net instead of your_domain.

To add an Active Directory user or group to a pool

  1. After joining the user's domain, in the Users tab, click Add.
  2. In the Add Users dialog box, enter one or more user or group names. Separate multiple names by commas. To specify a user in a different, trusted domain (other than the one currently joined), supply the domain name with the user name (for example, other_domain\jsmith) or enter a fully qualified domain name (FQDN) (for example, jsmith@other_domain.com).
  3. Click Grant Access.
  4. Follow Assign roles to users and groups to assign the account a role and give it access in XenServer Enterprise and higher.

To leave the domain

Note: When you leave the domain (that is, disable Active Directory authentication and disconnect a pool or server from its domain), any users who authenticated to the pool or server with Active Directory credentials are disconnected.
  1. In the Resources Pane, select the pool or server that you want to disconnect from its Active Directory domain.
  2. Click Leave Domain and select Yes to continue.
  3. Enter Active Directory credentials with sufficient privileges to disable servers in the domain you want to leave.
  4. Decide whether to disable the computer accounts in the Active Directory server, and then click one of the following:
    • Disable. Removes the pool or server from the domain and disables the computer account for the server or pool master in the Active Directory database.
    • Ignore. Select this option if you did not fill the username/password or you do not know an account with sufficient privileges to remove the server or pool master's computer account from the Active Directory database. (This option removes the pool or server from the domain, but leaves the computer account for the server or pool master in the Active Directory.)


RBAC overview

The Role Based Access Control (RBAC) feature lets you assign predefined roles, or sets of XenServer permissions, to Active Directory users and groups. These permissions control the level of access XenServer users (that is, people administering XenServer) have to servers and pools: RBAC is configured and deployed at the pool level. Because users acquire permissions through their assigned role, you simply need to assign a role to a user or their group.

Using Active Directory accounts for XenServer user accounts

RBAC lets you restrict which operations different groups of users can perform, which reduces the likelihood of inexperienced users making disastrous, accidental changes. Assigning RBAC roles also helps prevent unauthorized changes to your resource pools for compliance reasons. To facilitate compliance and auditing, RBAC also provides an Audit Log feature and its corresponding Workload Balancing Pool Audit Trail report.

RBAC depends on Active Directory for authentication services. Specifically, XenServer keeps a list of authorized users based on Active Directory user and group accounts. As a result, you must join the pool to the domain and add Active Directory accounts before you can assign roles.

Note: The RBAC feature is only available in Citrix XenServer Enterprise Edition or higher. To learn more about the features available in different XenServer Editions, click here.

If you do not have one of these editions, you can add users from Active Directory. However, all users will have the Pool Administrator role.

RBAC process

This is the standard process for implementing RBAC and assigning a user or group a role:

  1. Join the domain.
  2. Add an Active Directory user or group to the pool.
  3. Assign (or modify) the user or group's RBAC role.

Local Super User

The local super user (LSU), or root, is a special user account used for system administration and has all rights or permissions. In XenServer, the local super user is the default account at installation. The LSU is authenticated by XenServer and not an external authentication service. This means that if the external authentication service fails, the LSU can still log in and manage the system. The LSU can always access the XenServer physical server through SSH.

RBAC Roles

XenServer comes with six pre-established roles that are designed to align with different functions in an IT organization.

  • Pool Administrator (Pool Admin). This role is the most powerful role available. Pool Admins have full access to all XenServer features and settings. They can perform all operations, including role and user management. They can grant access to the XenServer console. As a best practice, Citrix recommends assigning this role to an extremely limited number of users.
    Note: The local super user (root) always has the Pool Admin role. The Pool Admin role has the same permissions as the local root.
  • Pool Operator (Pool Operator). This role is designed to let the assignee manage pool-wide resources, including creating storage, managing servers, managing patches, and creating pools. Pool Operators can configure pool resources. They also have full access to the following features: High Availability (HA), Workload Balancing, and patch management. Pool Operators cannot add users or modify roles.
  • Virtual Machine Power Administrator (VM Power Admin). This role has full access to VM and Template management. They can choose where to start VMs. They have full access to the dynamic memory control features and the VM snapshot feature. In addition, they can set the Home Server and choose where to run workloads. Assigning this role grants the assignee sufficient permissions to provision virtual machines for VM Operator use.
  • Virtual Machine Administrator (VM Admin). This role can manage VMs and Templates and access the storage necessary to complete these tasks. However, this role relies on XenServer to choose where to run workloads and must use the settings in templates for dynamic memory control and the Home Server. (This role cannot access the dynamic memory control features, make snapshots, set the Home Server or choose where to run workloads.)
  • Virtual Machine Operator (VM Operator). This role can use the VMs in a pool and manage their basic lifecycle. VM Operators can interact with the VM consoles and start or stop VMs, provided sufficient hardware resources are available. Likewise, VM Operators can perform start and stop lifecycle operations. The VM Operator role cannot create or destroy VMs, alter VM properties, or server resources.
  • Read-only (Read Only). This role can only view resource pool and performance data.

For information about the permissions associated with each role, see Definitions of RBAC roles and permissions. For information about how RBAC calculates which roles apply to a user, see Calculating RBAC roles.

Note: If you do not assign a new user account a role when you create it, XenServer assigns it the Pool Administrator role automatically. However, in XenServer Enterprise and Platinum editions, when you create new users, XenServer does not assign newly created user accounts roles automatically. You must assign roles to new accounts separately.

Upgrading from older XenServer releases

Support for RBAC was introduced at XenServer version 5.6. Any user accounts created in earlier XenServer releases are assigned the role of Pool Admin when upgrading to XenServer version 5.6 or later. This is done for backwards compatibility reasons. When upgrading from older XenServer releases, you should revisit the role associated with each user account to make sure it is still appropriate.


Definitions of RBAC roles and permissions

Permissions available for each role

The following table summarizes which permissions are available for each role. For details on the operations available for each permission, see the next section.

Permissions | Pool Admin | Pool Operator | VM Power Admin | VM Admin | VM Operator | Read Only
Assign/modify roles | X |  |  |  |  |
Log in to (physical) server consoles (through SSH and XenCenter) | X |  |  |  |  |
Server backup/restore | X |  |  |  |  |
Import/export OVF/OVA packages; import disk images | X |  |  |  |  |
Log out active user connections | X | X |  |  |  |
Create and dismiss alerts | X | X |  |  |  |
Cancel task of any user | X | X |  |  |  |
Pool management | X | X |  |  |  |
VM advanced operations | X | X | X |  |  |
VM create/destroy operations | X | X | X | X |  |
VM change CD media | X | X | X | X | X |
VM change power state | X | X | X | X | X |
View VM consoles | X | X | X | X | X |
XenCenter view management operations | X | X | X | X | X |
Cancel own tasks | X | X | X | X | X | X
Read audit logs | X | X | X | X | X | X
Configure, Initialize, Enable, Disable WLB | X | X |  |  |  |
Apply WLB Optimization Recommendations | X | X |  |  |  |
Modify WLB Report Subscriptions | X | X |  |  |  |
Accept WLB Placement Recommendations | X | X | X |  |  |
Display WLB Configuration | X | X | X | X | X | X
Generate WLB Reports | X | X | X | X | X | X
Connect to pool and read all pool metadata | X | X | X | X | X | X
Configure vGPU | X | X |  |  |  |
View vGPU configuration | X | X | X | X | X | X

Definitions of permissions

This table provides additional details about permissions:

Permission Allows Assignee To Rationale/Comments
Assign/modify roles
  • Add and remove users
  • Add and remove roles from users
  • Enable and disable Active Directory integration (being joined to the domain)

This permission lets the user grant himself or herself any permission or perform any task.

Warning: This role lets the user disable the Active Directory integration and all subjects added from Active Directory.

Log in to server consoles
  • Server console access through ssh
  • Server console access through XenCenter
Warning: With access to a root shell, the assignee could arbitrarily reconfigure the entire system, including RBAC.

Server backup/restore
VM create/destroy operations
  • Back up and restore servers
  • Back up and restore pool metadata
The ability to restore a backup lets the assignee revert RBAC configuration changes.
Import/export OVF/OVA packages; import disk images
  • Import OVF and OVA packages
  • Import disk images
  • Export VMs as OVF/OVA packages
Log out active user connections
  • Ability to disconnect logged in users
Create/dismiss alerts

Warning: A user with this permission can dismiss alerts for the entire pool.

Note: The ability to view alerts is part of the Connect to Pool and read all pool metadata permission.

Cancel task of any user
  • Cancel any user's running task
This permission lets the user request XenServer cancel an in-progress task initiated by any user.
Pool management
  • Set pool properties (naming, default SRs)
  • Enable, disable, and configure HA
  • Set per-VM HA restart priorities
  • Configure DR and perform DR failover, failback and test failover operations.
  • Enable, disable, and configure Workload Balancing (WLB)
  • Add and remove server from pool
  • Emergency transition to master
  • Emergency master address
  • Emergency recover slaves
  • Designate new master
  • Manage pool and server certificates
  • Patching
  • Set server properties
  • Configure server logging
  • Enable and disable servers
  • Shut down, reboot, and power-on servers
  • Restart toolstack
  • System status reports
  • Apply license
  • Live migration of all other VMs on a server to another server, due to either WLB, Maintenance Mode, or HA
  • Configure server management interfaces
  • Disable server management
  • Delete crashdumps
  • Add, edit, and remove networks
  • Add, edit, and remove PBDs/PIFs/VLANs/Bonds/SRs
Assign/modify roles
VM advanced operations
  • Adjust VM memory (through Dynamic Memory Control)
  • Create a VM snapshot with memory, take VM snapshots, and roll-back VMs
  • Migrate VMs
  • Start VMs, including specifying physical server
  • Resume VMs
Log in to server consoles
VM create/destroy operations
  • Install and delete VMs
  • Clone/copy VMs
  • Add, remove, and configure virtual disk/CD devices
  • Add, remove, and configure virtual network devices
  • Import/export XVA files
  • VM configuration change

Server backup/restore
VM create/destroy operations
VM change CD media
  • Eject current CD
  • Insert new CD
Import/export OVF/OVA packages; import disk images
VM change power state
  • Start VMs (automatic placement)
  • Shut down VMs
  • Reboot VMs
  • Suspend VMs
  • Resume VMs (automatic placement)
Log out active user connections
View VM consoles
  • See and interact with VM consoles
Create/dismiss alerts
Configure, Initialize, Enable, Disable WLB
  • Configure WLB
  • Initialize WLB and change WLB servers
  • Enable WLB
  • Disable WLB
Apply WLB Optimization Recommendations
  • Apply any optimization recommendations that appear in the WLB tab
Modify WLB Report Subscriptions
  • Change the WLB report generated or its recipient
Accept WLB Placement Recommendations
  • Select one of the servers Workload Balancing recommends for placement ("star" recommendations)
Display WLB Configuration
  • View WLB settings for a pool as shown on the WLB tab
Generate WLB Reports
  • View and run WLB reports, including the Pool Audit Trail report
XenCenter view management operations
  • Create and modify global XenCenter folders
  • Create and modify global XenCenter custom fields
  • Create and modify global XenCenter searches
View VM consoles
Cancel own tasks
  • Enables users to cancel their own tasks
Read audit log
  • Download the XenServer audit log
Apply WLB Optimization Recommendations
Connect to pool and read all pool metadata
  • Log in to pool
  • View pool metadata
  • View historical performance data
  • View logged in users
  • View users and roles
  • View tasks
  • View messages
  • Register for and receive events
Modify WLB Report Subscriptions
Configure vGPU
  • Specify a pool-wide placement policy
  • Assign a vGPU to a VM
  • Remove a vGPU from a VM
  • Modify allowed vGPU types
  • Create, destroy, or assign a GPU group
View vGPU configuration
  • View GPUs, GPU placement policies, and vGPU assignments.